using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Resources;
using System.Reflection;
using ReaderB;
using System.IO.Ports;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace UHFGate
{
   
    public partial class FrmUHFGate : Form
    {
        private byte ControllerAdr = 0xff;
        private int fCmdRet=30  ;
        private bool IsGetting ;         //Ƿִ'C'־,
        private bool  IsCloseApp;
        private string LastMessage ;      //洢ϴϢ,ڱȽ뱾λõϢȽ,
        private int PortHandle =-1;
        private byte FreeSpaceRate;
        private byte fModel ;
       // private bool stopping ;
        private int IF2Port ;
        private int IF2TagCount;
      //  private string strIF2Data ;
        private const byte OK  = 0x00;
        private const byte BackGroundDataErr= 0x05;
        private const byte ControlerInitializing  = 0x06;
        private const byte IndexOutOfRange = 0x07;
        private const byte FindConfigDataError= 0x08;
        private const byte Mode = 0x09;
        private const byte GetRecordTimeError = 0x0A;
        private const byte ConstraintSetEAS  = 0x0B;
        private const byte SaveNewIRError = 0x0C;
        private const byte ISWritting  = 0x0D;
        private const byte ErrorMessage  = 0xFF;
        private const byte FindingConfigData = 0x0F;
        private const byte CommunicationErr  = 0x30;
        private const byte RetCRCErr  = 0x31;
        private const byte RetDataErr = 0x32  ; //ݳ
        private const byte CommunicationBusy  = 0x33;
        public FrmUHFGate()
        { 
            InitializeComponent();
            this.SetStyle(ControlStyles.DoubleBuffer |
                          ControlStyles.AllPaintingInWmPaint |
                          ControlStyles.UserPaint, true);
            UpdateStyles();
        }
        private string GetReturnCodeDesc(int cmdRet)
        {
            switch (cmdRet)
            {
                case OK:
                return "Operation Successed";
                case Mode:
                return "Mode error";
                case ISWritting:
                return "Can not set stop record";
                case CommunicationErr:
                return "Communication error";
                case FindConfigDataError:
                return "Invalid Command";
                case IndexOutOfRange:
                return "Search out of range";
                case FindingConfigData:
                return "Are looking for information....";
                case RetCRCErr:
                return "CRC Check error";
                case GetRecordTimeError:
                return "Can not save New mode";
                case ControlerInitializing:
                return "Ongoing internal self-test....";
                case RetDataErr:
                return "Return data length error";
                case BackGroundDataErr:
                return "Record not exist or has expired";
                case CommunicationBusy:
                return "Communication Busy";
                case ConstraintSetEAS:
                return "Be forced in EAS mode";
                case SaveNewIRError:
                return "New direction Saved Failed";
                default:
                    return "";
            }
        }
        private void RefreshComPort()
        {
            StatusBar1.Panels[2].Text = "IF1: Closed ";
            StatusBar1.Panels[3].Text = "IF2: Closed";
            if (PortHandle == -1)
                StatusBar1.Panels[2].Text = "IF1:Closed ";
            else
                StatusBar1.Panels[2].Text = "IF1: COM" + PortHandle.ToString();
            if (IF2Port == -1)
                StatusBar1.Panels[3].Text = "IF2:Closed ";
            else
                StatusBar1.Panels[3].Text = "IF2: COM" + IF2Port.ToString();
        }
         private void  RefreshFreeRate(byte FreeRate )
        {
            if (FreeRate == 0X00)
                StatusBar1.Panels[1].Text = "Background to record data area of capacity idle> 15%";
            else if (FreeRate == 0x01)
                StatusBar1.Panels[1].Text = "Background record of idle capacity data area <15%";
            else if (FreeRate == 0x02)
                StatusBar1.Panels[1].Text = "Background data area record is full and has to stop the background records";
            else if (FreeRate == 0x03)
                StatusBar1.Panels[1].Text = "Background data area record is full and has begun recycling record";
            else
                StatusBar1.Panels[1].Text = " ";
        }
        private void AddCmdLog(string CMD ,string cmdStr, int cmdRet)
        {
            try
            {
                StatusBar1.Panels[0].Text = "";
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " +
                                            cmdStr + ": " +
                                            GetReturnCodeDesc(cmdRet);
            }
            finally
            {
                ;
            }
        }
         private void InitiComboBox()
         {
            ComboBox_Port.SelectedIndex = 0;
             MaxInventoryTime.SelectedIndex = 0;
            textCloseReaderTime.SelectedIndex = 0;
            TextStatTime.SelectedIndex = 7;
            TextTagOverTime.SelectedIndex = 4;
            TextTagQuietTime.SelectedIndex = 1;
            TextBlockMaxStayTime.SelectedIndex = 0;
            TextBackRecordConfig.SelectedIndex = 0;
            TextGreenLight.SelectedIndex = 0;
            ComboBox2.SelectedIndex = 0;
            ComboBox3.SelectedIndex = 0;
            ComboBox5.SelectedIndex = 0;
            ComboBox6.SelectedIndex = 0;
            ComboBox7.SelectedIndex = 0;
            ComboBox8.SelectedIndex = 0;
            ComboBox_Relay.SelectedIndex = 0;
           
            SetClock.Checked = true ;
          
            Set_Alarm.Checked = true;
            RadioButton2.Checked = true;
            RadioButton_Red.Checked = true;
            RadioButton6.Checked = true;
            RadioButton8.Checked = true;
            RadioButton14.Checked = true;
            RadioButton16.Checked = true;
            RadioButton5.Checked = true;
            RadioButton3.Checked = true;
            ComboBox13.SelectedIndex = 1;
            ComboBox14.SelectedIndex = 1;
             ComboBox15.SelectedIndex = 2;
            ComboBox16.SelectedIndex = 1;
            ComboBox17.SelectedIndex = 1;
            ComboBox18.SelectedIndex = 2;
            ComboBox19.SelectedIndex = 0;
            ComboBox20.SelectedIndex = 0;
            ComboBox21.SelectedIndex = 1;
            ComboBox39.SelectedIndex = 1;
            ComboBox38.SelectedIndex = 1;
            ComboBox37.SelectedIndex = 2;
            ComboBox36.SelectedIndex = 1;
            ComboBox35.SelectedIndex = 1;
             ComboBox34.SelectedIndex = 2;
            ComboBox33.SelectedIndex = 0;
            ComboBox32.SelectedIndex = 0;
            ComboBox31.SelectedIndex = 1;
            ComboBox48.SelectedIndex = 1;
             ComboBox47.SelectedIndex = 1;
            ComboBox46.SelectedIndex = 2;
            ComboBox45.SelectedIndex = 1;
            ComboBox44.SelectedIndex = 1;
            ComboBox43.SelectedIndex = 2;
             ComboBox42.SelectedIndex = 0;
            ComboBox41.SelectedIndex = 0;
            ComboBox40.SelectedIndex = 1;
            ComboBox57.SelectedIndex = 1;
            ComboBox56.SelectedIndex = 1;
            ComboBox55.SelectedIndex = 2;
            ComboBox54.SelectedIndex = 1;
            ComboBox53.SelectedIndex = 1;
            ComboBox52.SelectedIndex = 2;
            ComboBox51.SelectedIndex = 0;
             ComboBox50.SelectedIndex = 0;
            ComboBox49.SelectedIndex = 1;
            ComboBox102.SelectedIndex = 1;
            ComboBox101.SelectedIndex = 1;
            ComboBox100.SelectedIndex = 2;
             ComboBox99.SelectedIndex = 1;
            ComboBox98.SelectedIndex = 1;
            ComboBox97.SelectedIndex = 2;
            ComboBox96.SelectedIndex = 0;
            ComboBox95.SelectedIndex = 0;
            ComboBox94.SelectedIndex = 1;

         }
        private void InitiButton()
        {
            OpenPort.Enabled = true;
            ClosePort.Enabled = false;
            Btn_GetControllerInfo.Enabled = false;
            Btn_GetControllerParticInfo.Enabled = false;
            CloseIR.Enabled = false;
            OpenIR.Enabled = false;
            Btn_GetIRStatus.Enabled = false;
            SetRealy.Enabled = false;
            ClockCMD.Enabled = false;
            ClearBuffer.Enabled = false;
            GetReaderStatus.Enabled = false;
            button3.Enabled = false;
            button4.Enabled = false;
            ControllerInfo.Enabled = false;
            LEDAndBuzTest.Enabled = false;
            GetBackRecorfStatus.Enabled = false;
            SearchInRecord.Enabled = false;
            GetFirstRecord.Enabled = false;
            GetFirstRecordAndDel.Enabled = false;
            SaveRecordAsTextFile.Enabled = false;
            SaveAndDeleteAll.Enabled = false;
            Btn_DeleteAllRecord.Enabled = false;
            SetControAddr.Enabled = false;
            ControAddr.Enabled = false;
            SetMode.Enabled = false;
            GetMode.Enabled = false;
            Button1.Enabled = false;
            Button2.Enabled = false;
            Button5.Enabled = false;
            Button6.Enabled = false;
            Button7.Enabled = false;
            Button8.Enabled = false;
            IF1Start.Enabled = false;
            Button11.Enabled = false;
            //Button12.Enabled = false
            Button13.Enabled = false;
            //Button14.Enabled = false
            Button17.Enabled = false;
            Button18.Enabled = false;
            Button15.Enabled = false;
            Button16.Enabled = false;
            Button20.Enabled = false;
            Button23.Enabled = false;
            button10.Enabled = false;
            button22.Enabled = false;
        }
         private void EnableButton()
         {
            OpenPort.Enabled = false;
            ClosePort.Enabled = true;
            Btn_GetControllerInfo.Enabled = true;
            CloseIR.Enabled = true;
            OpenIR.Enabled = true;
            Btn_GetIRStatus.Enabled = true;
            SetRealy.Enabled = true;
            ClockCMD.Enabled = true;
            ClearBuffer.Enabled = true;
            GetReaderStatus.Enabled = true;
            button3.Enabled = true;
            button4.Enabled = true;
            ControllerInfo.Enabled = true;
            LEDAndBuzTest.Enabled = true;
            GetBackRecorfStatus.Enabled = true;
            SearchInRecord.Enabled = true;
            GetFirstRecord.Enabled = true;
            GetFirstRecordAndDel.Enabled = true;
            SaveRecordAsTextFile.Enabled = true;
            SaveAndDeleteAll.Enabled = true;
            Btn_DeleteAllRecord.Enabled = true;
            SetControAddr.Enabled = true;
            ControAddr.Enabled = true;
            SetMode.Enabled = true;
            GetMode.Enabled = true;
            Button1.Enabled = true;
            Button2.Enabled = true;
            Button5.Enabled = true;
            Button6.Enabled = true;
            Button7.Enabled = true;
            Button8.Enabled = true;
            Button15.Enabled = true;
            Button16.Enabled = true;
            Button20.Enabled = true;
            Button23.Enabled = true;
            button10.Enabled = true;
            button22.Enabled = true;
         }

        private void UHFGate_Load(object sender, EventArgs e)
        {
            string[] sp;
            int i;
             ComboBox_Port.Items.Add("Auto");
             sp = SerialPort.GetPortNames();
             for (i = 0; i < sp.Length ; i++)
             {
                 ComboBox_Port.Items.Add(sp[i]);
             }
            InitiComboBox();
            InitiButton();
            IF2Port = -1;
            PortHandle = -1;
            IF2TagCount = 0;
            IsGetting = false ;       
            IsCloseApp = false;
            radioButton11.Checked = true;
            radioButton_EAS.Checked = true;
        }
        #region  16ַ֮໥ת
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        #endregion

        private void OpenPort_Click(object sender, EventArgs e)
        {
            String temp ="";
            byte Productcode=0; 
            byte MainVer=0 ;
            byte SubVer=0;
            int portNum = -1;
            try
            {
                
                if (ControlAddr.Text == "" )
                {
                    MessageBox.Show("Please input the address to open the controller", "Information");
                    return ;
                }
                OpenPort.Enabled = false;
                ControllerAdr = Convert.ToByte(ControlAddr.Text, 16);
                Cursor = Cursors.WaitCursor;
                 if (ComboBox_Port.SelectedIndex == 0) 
                    fCmdRet = StaticClassReaderB.AutoOpenComPort(ref portNum,ref  ControllerAdr,ref  PortHandle);
                 else
                 {
                    temp = ComboBox_Port.SelectedItem.ToString();
                    portNum = Convert.ToByte(temp.Substring(3, temp.Length - 3));
                    fCmdRet = StaticClassReaderB.OpenComPort(portNum,ref ControllerAdr,ref PortHandle);
                 }
                 if (fCmdRet == 0)
                 {
                    StatusBar1.Panels[2].Text = "IF1:COM" + portNum.ToString();
                    EnableButton();
                    if (StaticClassReaderB.GetControllerInfo(ref ControllerAdr,ref Productcode,ref MainVer,ref SubVer,ref FreeSpaceRate, PortHandle) == 0)
                    { 
                        TextBox1.Text = Convert.ToString(Productcode,16).PadLeft(2,'0').ToUpper();
                        TextBox2.Text = Convert.ToString(MainVer,16).PadLeft(2, '0') + "."+ Convert.ToString(SubVer,16).PadLeft(2, '0');
                        if (Convert.ToByte(MainVer) > 6 )
                            Btn_GetControllerParticInfo.Enabled = true;
                    }
                    if (StaticClassReaderB.ModeSwitch(ref ControllerAdr,ref fModel, ref FreeSpaceRate, PortHandle) == 0) 
                    {
                        if (fModel == 0) 
                            IF1Start.Enabled = true;
                        if (fModel == 1) 
                            Button17.Enabled = true;
                        
                        if ((fModel & 0x02) == 0x02) 
                            Button17.Enabled = true;
                    }
                 }
                 else
                 {
                     MessageBox.Show("OpenComPort failed", "Communication");
                     OpenPort.Enabled = true;
                     
                 }
               
            }
            finally
            {
             AddCmdLog("OpenComPort", "OpenComPort", fCmdRet);
             OpenPort.Enabled = !(fCmdRet==0);
             Cursor = Cursors.Default;
            }
        }

        private void ClosePort_Click(object sender, EventArgs e)
        {
             StaticClassReaderB.CloseComPort();
            PortHandle = -1;
            InitiButton();
            RefreshComPort();
            ConnectStatus.Text = "";
            ANTStatus.Text = "";
            TextBox1.Text = "";
            TextBox2.Text = "";
            TextBox3.Text = "";
            TextBox4.Text = "";
           // TextBox5.Text = "";
            TextBox6.Text = "";
            TextBox7.Text = "";
            TextBox10.Text = "";
            TextBox11.Text = "";
            TextBox12.Text = "";
            TextBox14.Text = "";
            Text_year.Text = "";
            Text_month.Text = "";
            Text_day.Text = "";
            Text_min.Text = "";
            Text_hour.Text = "";
            Text_sec.Text = "";
            ListBox2.Items.Clear();
            ListBox3.Items.Clear();
            ListBox4.Items.Clear();
            listBox5.Items.Clear();
            ListBox7.Items.Clear();
            ListBox8.Items.Clear();
            ListBox9.Items.Clear();
            ListBox10.Items.Clear();
            ListBox11.Items.Clear();
            StatusBar1.Panels[0].Text = " ";
            StatusBar1.Panels[1].Text = " ";
        }

        private void CheckBox9_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Btn_GetControllerInfo_Click(object sender, EventArgs e)
        {
            byte Productcode = 0;
            byte MainVer = 0;
            byte SubVer = 0;
            TextBox1.Text = "";
            TextBox2.Text = "";
            TextBox3.Text = "";
            fCmdRet = StaticClassReaderB.GetControllerInfo(ref ControllerAdr, ref Productcode, ref MainVer, ref SubVer, ref FreeSpaceRate, PortHandle);
            if (fCmdRet==0)       
            { 
                TextBox1.Text = Convert.ToString(Productcode,16).PadLeft(2,'0').ToUpper();
                TextBox2.Text = Convert.ToString(MainVer,16).PadLeft(2, '0') + "."+ Convert.ToString(SubVer,16).PadLeft(2, '0');
                if (Convert.ToByte(MainVer) > 6 )
                    Btn_GetControllerParticInfo.Enabled = true;
            }
             AddCmdLog("I", "Information", fCmdRet);
             StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0) 
            RefreshFreeRate(FreeSpaceRate);
        }

        private void Btn_GetControllerParticInfo_Click(object sender, EventArgs e)
        {
            byte Productcode=0 ;
            byte  MainVer=0 ;
            byte SubVer=0;      
            byte[] SerialNumber = new byte[4];
            TextBox1.Text = "";
            TextBox2.Text = "";
            TextBox3.Text = "";
            fCmdRet = StaticClassReaderB.GetControllerDetailedInfo(ref  ControllerAdr,ref  Productcode,ref  MainVer,ref  SubVer, SerialNumber,ref  FreeSpaceRate, PortHandle);
            if ((fCmdRet & 0x3F) == 0) 
            {
                TextBox1.Text = Convert.ToString(Productcode,16).PadLeft(2,'0').ToUpper();
                TextBox2.Text = Convert.ToString(MainVer,16).PadLeft(2, '0') + "."+ Convert.ToString(SubVer,16).PadLeft(2, '0');
                // SNR = SNR + CStr(SerialNumber(0))
                TextBox3.Text = Convert.ToString(SerialNumber[3], 16).PadLeft(2, '0') + "-" + Convert.ToString(SerialNumber[2], 16).PadLeft(2, '0') + "-" + Convert.ToString(SerialNumber[1], 16).PadLeft(2, '0') + "-" + Convert.ToString(SerialNumber[0], 16).PadLeft(2, '0');
                AddCmdLog("I", "Detailed", fCmdRet);
                StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0) 
                RefreshFreeRate(FreeSpaceRate);
            }
        }

        private void CloseIR_Click(object sender, EventArgs e)
        {
            byte CloseIR = 0x01;
             fCmdRet = StaticClassReaderB.SetIR(ref ControllerAdr, CloseIR, ref FreeSpaceRate, PortHandle);
             AddCmdLog("I", "Close", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0) 
            RefreshFreeRate(FreeSpaceRate);
        }

        private void OpenIR_Click(object sender, EventArgs e)
        {
            byte CloseIR = 0x02;
            fCmdRet = StaticClassReaderB.SetIR(ref ControllerAdr, CloseIR, ref FreeSpaceRate, PortHandle);
            AddCmdLog("I", "Active", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0) 
            RefreshFreeRate(FreeSpaceRate);
        }

        private void Btn_GetIRStatus_Click(object sender, EventArgs e)
        {
            byte IRStatuas =0;
            fCmdRet = StaticClassReaderB.GetIRStatus(ref ControllerAdr,ref IRStatuas,ref  FreeSpaceRate, PortHandle);
            if( IRStatuas == 1 )
                TextBox4.Text = "Active";
             if( IRStatuas == 0 )
                TextBox4.Text = "Closed";
            AddCmdLog("I", "Query", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0) 
                RefreshFreeRate(FreeSpaceRate);
        }

        private void SetRealy_Click(object sender, EventArgs e)
        {
            byte TactTime;
            TactTime = Convert.ToByte(ComboBox_Relay.SelectedIndex.ToString());
            fCmdRet = StaticClassReaderB.SetRelay(ref ControllerAdr, TactTime, ref FreeSpaceRate, PortHandle);
            AddCmdLog("C", "Set Relay", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0) 
                RefreshFreeRate(FreeSpaceRate);
        }

        private void ClearBuffer_Click(object sender, EventArgs e)
        {
            fCmdRet = StaticClassReaderB.ClearControllerBuffer(ref ControllerAdr,ref FreeSpaceRate, PortHandle);
            AddCmdLog("ClearBuffer", "Clear Controller Buffers", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0) 
                    RefreshFreeRate(FreeSpaceRate);
        }

        private void ClockCMD_Click(object sender, EventArgs e)
        {
            byte[] setTime = new byte[6];
            byte[] outTime = new byte[6];
            if (SetClock.Checked )
            {
                if (Text_year.Text == "" || Text_month.Text == "" || Text_day.Text == "" || Text_hour.Text == "" || Text_min.Text == "" || Text_sec.Text == "" )
                {
                    MessageBox.Show("Please Input Data", "Information");
                    return;
                }
                setTime[0] = Convert.ToByte(Text_year.Text);
                setTime[1] = Convert.ToByte(Text_month.Text);
                setTime[2] = Convert.ToByte(Text_day.Text);
                setTime[3] = Convert.ToByte(Text_hour.Text);
                setTime[4] = Convert.ToByte(Text_min.Text);
                setTime[5] = Convert.ToByte(Text_sec.Text);
                if (Convert.ToByte(Text_year.Text) < 0 || Convert.ToByte(Text_year.Text) > 99 )
                {
                    MessageBox.Show("Please Input Any Data Between 00-99", "Information");
                    return;
                }
                fCmdRet = StaticClassReaderB.SetClock(ref ControllerAdr, setTime,ref FreeSpaceRate, PortHandle);
                AddCmdLog("@", "Set Clock", fCmdRet);
            }
                   
            if (GetClock.Checked )
            {
                fCmdRet = StaticClassReaderB.GetClock(ref ControllerAdr, setTime,ref FreeSpaceRate, PortHandle);
                if (fCmdRet == 0 )
                {
                    Text_year.Text = Convert.ToString(setTime[0]).PadLeft(2, '0');
                    Text_month.Text = Convert.ToString(setTime[1]).PadLeft(2, '0');
                    Text_day.Text = Convert.ToString(setTime[2]).PadLeft(2, '0');
                    Text_hour.Text = Convert.ToString(setTime[3]).PadLeft(2, '0');
                    Text_min.Text = Convert.ToString(setTime[4]).PadLeft(2, '0');
                    Text_sec.Text = Convert.ToString(setTime[5]).PadLeft(2, '0');
                    AddCmdLog("@", "Query Clock", fCmdRet);
                }
            }
            
            StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0) 
                    RefreshFreeRate(FreeSpaceRate);
        }

        private void GetReaderStatus_Click(object sender, EventArgs e)
        {
            byte ConStat=0 ;
            byte ANTStat=0 ;
            ConnectStatus.Text = "";
            ANTStatus.Text = "";
            fCmdRet = StaticClassReaderB.GetControllerReaderConnectionStatus(ref ControllerAdr,ref  ConStat,ref ANTStat,ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0) 
            {
                if (ConStat == 1)
                    ConnectStatus.Text = "Normal";
                if (ANTStat == 0) 
                    ANTStatus.Text = "Off";
                else if( ANTStat == 1)
                    ANTStatus.Text = "On";
                else if (ANTStat == 2)
                    ANTStatus.Text = "Rf On......";
                else
                ConnectStatus.Text = "Disconnected";
                RefreshFreeRate(FreeSpaceRate);
            }
            AddCmdLog("Z", "Get Reader Status", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0) 
                RefreshFreeRate(FreeSpaceRate);
        }



        private void ControllerInfo_Click(object sender, EventArgs e)
        {
            byte ReaderInventoryTime ;
            byte CloseReaderTime ;
            byte StatTime ;
            byte TagOverTime ;
            byte TagQuietTime ;
            byte BlockMaxStayTime;
            byte BackRecordConfig ;
            byte GreenPromptOn;
            ReaderInventoryTime = Convert.ToByte(MaxInventoryTime.SelectedItem);
            CloseReaderTime = Convert.ToByte(textCloseReaderTime.SelectedItem);
            StatTime = Convert.ToByte(TextStatTime.SelectedItem);
            TagOverTime = Convert.ToByte(TextTagOverTime.SelectedItem);
            TagQuietTime = Convert.ToByte(TextTagQuietTime.SelectedItem);
            BlockMaxStayTime = Convert.ToByte(TextBlockMaxStayTime.SelectedItem);
            BackRecordConfig = Convert.ToByte(TextBackRecordConfig.SelectedIndex);
            if (TextGreenLight.SelectedIndex == 0)
                GreenPromptOn = 1;
            else
                GreenPromptOn = 0;
             if (RadioButton1.Checked )
             {
                fCmdRet = StaticClassReaderB.ConfigureController(ref ControllerAdr, ReaderInventoryTime, CloseReaderTime, StatTime, TagOverTime, TagQuietTime, BlockMaxStayTime, BackRecordConfig, GreenPromptOn,ref FreeSpaceRate, PortHandle);
                AddCmdLog("F", "Set Configure Information", fCmdRet);
             }
             if (RadioButton2.Checked)
             { 
                fCmdRet = StaticClassReaderB.GetControllerConfig(ref ControllerAdr,ref ReaderInventoryTime,ref CloseReaderTime,ref StatTime,ref TagOverTime,ref TagQuietTime,ref BlockMaxStayTime,ref BackRecordConfig,ref GreenPromptOn,ref FreeSpaceRate, PortHandle);
                MaxInventoryTime.SelectedIndex = ReaderInventoryTime - 30;
                textCloseReaderTime.SelectedIndex = CloseReaderTime;
                TextStatTime.SelectedIndex = StatTime - 3;
                TextTagOverTime.SelectedIndex = TagOverTime - 1;
                TextTagQuietTime.SelectedIndex = TagQuietTime - 1;
                TextBlockMaxStayTime.SelectedIndex = BlockMaxStayTime - 3;
                if (GreenPromptOn == 0)
                    TextGreenLight.SelectedIndex = 1;
                else
                    TextGreenLight.SelectedIndex = 0;
                if (BackRecordConfig == 0)
                    TextBackRecordConfig.SelectedIndex = 0;
                else
                    TextBackRecordConfig.SelectedIndex = 1;
                AddCmdLog("R", "Get Configure Information", fCmdRet);
             }
             StatusBar1.Panels[1].Text = " ";
             if (fCmdRet == 0)
                 RefreshFreeRate(FreeSpaceRate);
        }

        private void LEDAndBuzTest_Click(object sender, EventArgs e)
        {
            byte BuzActTime ;
            byte BuzQuiteTime;
            byte BuzzerActTimes ;
            byte LEDOnTime;
            byte LEDOffTime ;
            byte LEDFlickerTimes ;
            byte LEDColor;
            BuzActTime = Convert.ToByte(ComboBox7.SelectedIndex);
            BuzQuiteTime = Convert.ToByte(ComboBox6.SelectedIndex);
            BuzzerActTimes = Convert.ToByte(ComboBox8.SelectedIndex);
            LEDOnTime = Convert.ToByte(ComboBox2.SelectedIndex);
            LEDOffTime = Convert.ToByte(ComboBox3.SelectedIndex);
            LEDFlickerTimes = Convert.ToByte(ComboBox5.SelectedIndex);
            if (RadioButton_Red.Checked)
                LEDColor = 0;
            else
                LEDColor = 1;
            fCmdRet = StaticClassReaderB.BuzzerAndLEDControl(ref ControllerAdr, BuzActTime, BuzQuiteTime, BuzzerActTimes, LEDOnTime, LEDOffTime, LEDFlickerTimes, LEDColor,ref FreeSpaceRate, PortHandle);
            AddCmdLog("B", "Go", fCmdRet);
           StatusBar1.Panels[1].Text = " ";
             if (fCmdRet == 0)
                 RefreshFreeRate(FreeSpaceRate);
        }

        private void GetBackRecorfStatus_Click(object sender, EventArgs e)
        {
            int  RecordCount=0 ;
            string  TimeTemp ;
            byte[] FirstRecordTime=new byte[16];
            byte[] LastRecordTime=new byte[16];
            TextBox10.Text = "";
            TextBox6.Text = "";
            TextBox7.Text = "";
            fCmdRet = StaticClassReaderB.GetBGLogDataStatus(ref ControllerAdr,ref RecordCount, FirstRecordTime, LastRecordTime,ref FreeSpaceRate, PortHandle);
            TextBox6.Text = Convert.ToString(RecordCount);
            if (RecordCount != 0)
            {
                TimeTemp = "20" + Convert.ToString(FirstRecordTime[0]).PadLeft(2, '0') + "-" + Convert.ToString(FirstRecordTime[1]).PadLeft(2, '0') + "-" + Convert.ToString(FirstRecordTime[2]).PadLeft(2, '0') + " " + Convert.ToString(FirstRecordTime[3]).PadLeft(2, '0') + ":" + Convert.ToString(FirstRecordTime[4]).PadLeft(2, '0') + ":" + Convert.ToString(FirstRecordTime[5]).PadLeft(2, '0');
                TextBox7.Text = TimeTemp;
                TimeTemp = "20" + Convert.ToString(LastRecordTime[0]).PadLeft(2, '0') + "-" + Convert.ToString(LastRecordTime[1]).PadLeft(2, '0') + "-" + Convert.ToString(LastRecordTime[2]).PadLeft(2, '0') + " " + Convert.ToString(LastRecordTime[3]).PadLeft(2, '0') + ":" + Convert.ToString(LastRecordTime[4]).PadLeft(2, '0') + ":" + Convert.ToString(LastRecordTime[5]).PadLeft(2, '0');
                TextBox10.Text = TimeTemp;
            }
            AddCmdLog("S", "Query", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void SetControAddr_Click(object sender, EventArgs e)
        {
            byte NewAddr=0;
            byte Mode=1;
            if (TextNewConAddr.Text != "")
                NewAddr = Convert.ToByte(TextNewConAddr.Text,16);
            else
            {
                MessageBox.Show("Please Input New Controller Address", "Information");
                return;
            }
            fCmdRet = StaticClassReaderB.SetControllerAddr(ref ControllerAdr, Mode, NewAddr, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0) 
                ControllerAdr = NewAddr;
            AddCmdLog("K", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void ControAddr_Click(object sender, EventArgs e)
        {
            byte NewAddr = 0;
            byte Mode = 0;
             fCmdRet = StaticClassReaderB.SetControllerAddr(ref ControllerAdr, Mode, NewAddr, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
                TextBox14.Text = Convert.ToString(ControllerAdr,16).PadLeft(2, '0');
            AddCmdLog("K", "Get", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }


        private void SetMode_Click(object sender, EventArgs e)
        {
            fModel = 0x00;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr,ref fModel,ref FreeSpaceRate, PortHandle);
            if ((fModel & 0x02) == 0x02 )
            {
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Be forced in EAS mode";
                return ;
            }
            if (RadioButton6.Checked)
                fModel = 0x80  ;  
            if (RadioButton7.Checked )
                fModel = 0x81;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr,ref fModel,ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0 )
            {
                if (fModel == 0 )
                {
                    IF1Start.Enabled = true;
                    Button11.Enabled = false;
                    Button17.Enabled = false;
                    Button18.Enabled = false;
                }
                if (fModel == 1)
                {
                    IF1Start.Enabled = false;
                    Button11.Enabled = false;
                    Button17.Enabled = true;
                    Button18.Enabled = false;
                }
            }
            AddCmdLog("M", "Set", fCmdRet);
              StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void GetMode_Click(object sender, EventArgs e)
        {
            fModel = 0x00;
            fCmdRet = StaticClassReaderB.ModeSwitch(ref ControllerAdr,ref fModel,ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0 )
            {
                if (fModel == 0)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Channel Mode";             
                if (fModel == 1)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "EAS Mode";
                if ((fModel & 0x02) == 0x02) 
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Be forced in EAS Mode";
                StatusBar1.Panels[1].Text = "";
                RefreshFreeRate(FreeSpaceRate);
            }
            else
                AddCmdLog("M", "Get", fCmdRet);
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            byte model=0;
            if (RadioButton8.Checked )
                model = 0x80;
            if (RadioButton9.Checked)
                model = 0x81;
            fCmdRet = StaticClassReaderB.IRDirectionSetting(ref ControllerAdr,ref model,ref FreeSpaceRate, PortHandle);
            AddCmdLog("N", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void Button2_Click(object sender, EventArgs e)
        {      
            byte model  = 0;
            fCmdRet = StaticClassReaderB.IRDirectionSetting(ref ControllerAdr,ref model,ref FreeSpaceRate, PortHandle);
            if (fCmdRet != 0)
            {
                AddCmdLog("B", "Get", fCmdRet);
                return;
            }
            if (model == 0 )
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Normal infrared sensor sequence";
            if (model == 1 )
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Reversed infrared sensor sequence";
        }

        private void Button5_Click(object sender, EventArgs e)
        {
            byte model =0;
            if (RadioButton14.Checked )
                model = 0x80;
            if (RadioButton15.Checked )
                model = 0x81;
            fCmdRet = StaticClassReaderB.ControllerReaderConnectionBrokenAlarm(ref ControllerAdr,ref model,ref FreeSpaceRate, PortHandle);
            AddCmdLog("N", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void Button6_Click(object sender, EventArgs e)
        {
             byte model=0; 
        fCmdRet = StaticClassReaderB.ControllerReaderConnectionBrokenAlarm(ref ControllerAdr,ref model,ref FreeSpaceRate, PortHandle);
        if (fCmdRet == 0 )
        {
            if (model == 0 )
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "No alarm";
            if (model == 1)
                StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Alarm";
            StatusBar1.Panels[1].Text = "";
            RefreshFreeRate(FreeSpaceRate);
        }
        else
            AddCmdLog("N", "Get", fCmdRet);
        }

        private void Button7_Click(object sender, EventArgs e)
        {
            byte model=0;
            if (RadioButton16.Checked)
                model = 0x00;
            if (RadioButton17.Checked)
                model = 0x01;
            fCmdRet = StaticClassReaderB.SetBGLogDataStatus(ref ControllerAdr,ref model,ref FreeSpaceRate, PortHandle);
            AddCmdLog("a", "Set", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void Button8_Click(object sender, EventArgs e)
        {
            byte[] Msg=new byte[6];
            byte InFlag =0;
            fCmdRet = StaticClassReaderB.GetBGLogDataRecordingStatus(ref ControllerAdr, Msg,ref FreeSpaceRate, PortHandle);
            if (fCmdRet != 0)
                AddCmdLog("b", "Get", fCmdRet);
            else
            {
                InFlag = Convert.ToByte(Msg[0]);
                if ((InFlag & 0x01) == 0)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Stop";
                if ((InFlag & 0x01) == 1)
                    StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "Start";
                StatusBar1.Panels[1].Text = " ";
                if (fCmdRet == 0)
                    RefreshFreeRate(FreeSpaceRate);
            }
        }

        private void Button16_Click(object sender, EventArgs e)
        {
            fCmdRet = 30;
            byte flag =0;
            StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "";
            if (RadioButton5.Checked)
                flag = 1;
            if (RadioButton10.Checked)
                flag = 0;
            fCmdRet = StaticClassReaderB.SaveRestoreConfig(ref ControllerAdr,  flag, ref FreeSpaceRate, PortHandle);
            AddCmdLog("f", "Go", fCmdRet);
        }

        private void Button15_Click(object sender, EventArgs e)
        {
            byte model = 0;
            StatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString() + " " + "";
            if (RadioButton3.Checked )
                model = 1;
            if (RadioButton4.Checked )
                model = 0;
            fCmdRet = StaticClassReaderB.SetAutoLoad(ref ControllerAdr, model,ref FreeSpaceRate, PortHandle);
            AddCmdLog("r", "Go", fCmdRet);
        }

        private void Text_year_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);  // ""˸ 
        }

        private void TextNewConAddr_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void GetFirstRecord_Click(object sender, EventArgs e)
        {
            string UID, UID1, InOrOut;
            byte InFlag, MsgLength, recordType;
            byte[] Msg = new byte[16];
            string year, month, Dates, Hour, minutes, second;
            string Time, Time1;
            int  EnterCount, LeaveCount, UnsureCount, CardNum;
            MsgLength = 0;
            recordType = 0;
            InOrOut = "";
            Time1 = "";
            fCmdRet = StaticClassReaderB.RetrieveEarliestRecord(ref ControllerAdr, Msg,ref MsgLength,ref recordType,ref FreeSpaceRate, PortHandle);         
            if ((fCmdRet == 0) &&(recordType == 0)) 
            {
                UID = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID1 = UID1.ToUpper();
                InFlag = Convert.ToByte(Msg[8]);
                switch (InFlag)
                {
                    case 1:
                        InOrOut = "Forward";
                        break;
                    case 2:
                        InOrOut = "Reverse";
                        break;
                    case 3:
                        InOrOut = "Direction Uncertain";
                        break;
                    case 4:
                        InOrOut = "Infrared sensors closed";
                        break;     
           
                }
                year = Convert.ToString(Msg[9]).PadLeft(2, '0');
                month = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[12]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[13]).PadLeft(2, '0');
                second = Convert.ToString(Msg[14]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " "+ Hour + ":" + minutes + ":" +second;
                 if ((UID == "0000000000000000") || (InFlag == 0))
                    TextBox11.Text = "First Record  " + Time + " None";
                 else if (UID == "FFFFFFFFFFFFFFFF")
                    TextBox11.Text = "First Record " + Time + " " + UID1 + " " + InOrOut;
                 else if (InOrOut == "Infrared sensors closed" )
                    TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + "Infrared sensors closed";
                else
                    TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + InOrOut;
            }
            else if((fCmdRet == OK) && (recordType == 1))
            {
                EnterCount = Msg[1] << 8;
                EnterCount = EnterCount | Msg[0];

                LeaveCount = Msg[3]<< 8;
                LeaveCount = LeaveCount | Msg[2];

                UnsureCount = Msg[5] << 8;
                UnsureCount = UnsureCount | Msg[4];

                CardNum = Msg[7] << 8;
                CardNum = CardNum |Msg[6];
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record   " + Time + " " + EnterCount + " Forward " + LeaveCount + " Reverse " + UnsureCount + " Direction Uncertain " + " Total Detect " + CardNum +" Tags";
            }
            else if ((fCmdRet == 0) && (recordType == 2))
            {
                UID = Convert.ToString(Msg[0],16).PadLeft(2, '0') +Convert.ToString(Msg[1],16).PadLeft(2, '0') + Convert.ToString(Msg[2],16).PadLeft(2, '0') + Convert.ToString(Msg[3],16).PadLeft(2, '0')  +Convert.ToString(Msg[4],16).PadLeft(2, '0')  + Convert.ToString(Msg[5],16).PadLeft(2, '0')  +Convert.ToString(Msg[6],16).PadLeft(2, '0')  +Convert.ToString(Msg[7],16).PadLeft(2, '0') ;
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[1],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[2],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[3],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[4],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[5],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[6],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[7],16).PadLeft(2, '0') ;
                UID1 = UID1.ToUpper();
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + "  Tag-exist time-overflow";
            }
            else if ((fCmdRet == 0) &&(recordType == 3))
            {
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record   " + Time + " Infrared-block-time-overflow";
            }
            else if ((fCmdRet == OK) && (recordType == 4))
            {
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record  " + Time + " Infrared-interference-warning";
            }
            else if ((fCmdRet == OK) &&(recordType == 8)) 
            {
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                year = Convert.ToString(Msg[6]).PadLeft(2, '0');
                month = Convert.ToString(Msg[7]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[8]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[9]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[10]).PadLeft(2, '0');
                second = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Time1 = "20" + year + "-" + month + "-" + Dates + "-" + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record " + "Set Real-time Clock " + "Before Clock Set:  " + Time + "  " + "After Clock Set:  " + Time1;
            }
            AddCmdLog("E", "Get Earliest Record", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void SearchInRecord_Click(object sender, EventArgs e)
        {
            string UID, UID1, InOrOut ;
            byte InFlag, RecordLength, recordType ;
            byte[] RecordData=new byte[16];
            string year, month, Dates, Hour, minutes, second ;
            string Time, Time1 ;
            int RecordIndex, EnterCount, LeaveCount, UnsureCount, CardNum;
            RecordLength = 0;
            recordType = 0;
            InOrOut ="";
            Time1 = "";
            if (TextBox12.Text == "")
            {
                MessageBox.Show("Please Input Record Sequence Number", "Information");
                return;
            }
            RecordIndex = Convert.ToInt32(TextBox12.Text);
            if (RecordIndex == 0)
            {
                MessageBox.Show("Input Record Sequence Number Must Be Greater Than 0", "Information");
                return;
            }
            TextBox11.Text = "";
            fCmdRet = StaticClassReaderB.RetrieveRecordByIndex(ref ControllerAdr, RecordIndex, RecordData,ref RecordLength,ref recordType,ref FreeSpaceRate, PortHandle);
            if ((fCmdRet == 0) && (recordType ==0))
            {
                UID = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                UID = UID.ToUpper();
                UID1 = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                UID1 = UID1.ToUpper();
                InFlag = Convert.ToByte(RecordData[8]);
                switch (InFlag)
                {
                    case 1:
                        InOrOut = "Forward";
                        break;
                    case 2:
                            InOrOut = "Reverse";
                            break;
                    case 3:
                            InOrOut = "Direction Uncertain";
                            break;
                    case 4:
                            InOrOut = "Infrared sensors closed";
                            break;
                }
                year = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[14]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " "+ Hour + ":" + minutes + ":" +second;
                if ((UID == "0000000000000000") || (InFlag == 0))
                    TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " None";
                else if (UID == "FFFFFFFFFFFFFFFF")
                    TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + InOrOut;
                else if (InOrOut == "Infrared sensors closed" )
                    TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + "Infrared sensors closed";
                else
                    TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + InOrOut;
            }
            else if ((fCmdRet == OK) &&(recordType == 1))
            {
                EnterCount = RecordData[1] << 8;
                EnterCount = EnterCount | RecordData[0];

                LeaveCount = RecordData[3]<< 8;
                LeaveCount = LeaveCount | RecordData[2];

                UnsureCount = RecordData[5] << 8;
                UnsureCount = UnsureCount | RecordData[4];

                CardNum = RecordData[7] << 8;
                CardNum = CardNum |RecordData[6];
                year = Convert.ToString(RecordData[8]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "No." + Convert.ToString(RecordIndex) +" Record  " + Time +" " + EnterCount + " Forward " + LeaveCount + " Reverse " + UnsureCount + " Direction Uncertain " + " Total Detect " + CardNum + " Tags";
            }
            else if ((fCmdRet == 0) && (recordType == 2))
            {
                UID = Convert.ToString(RecordData[0],16).PadLeft(2, '0') +Convert.ToString(RecordData[1],16).PadLeft(2, '0') + Convert.ToString(RecordData[2],16).PadLeft(2, '0') + Convert.ToString(RecordData[3],16).PadLeft(2, '0')  +Convert.ToString(RecordData[4],16).PadLeft(2, '0')  + Convert.ToString(RecordData[5],16).PadLeft(2, '0')  +Convert.ToString(RecordData[6],16).PadLeft(2, '0')  +Convert.ToString(RecordData[7],16).PadLeft(2, '0') ;
                UID = UID.ToUpper();
                UID1 = Convert.ToString(RecordData[0],16).PadLeft(2, '0')  + " " + Convert.ToString(RecordData[1],16).PadLeft(2, '0')  + " " +Convert.ToString(RecordData[2],16).PadLeft(2, '0')  + " " + Convert.ToString(RecordData[3],16).PadLeft(2, '0')  + " " +Convert.ToString(RecordData[4],16).PadLeft(2, '0')  + " " + Convert.ToString(RecordData[5],16).PadLeft(2, '0')  + " " +Convert.ToString(RecordData[6],16).PadLeft(2, '0')  + " " +Convert.ToString(RecordData[7],16).PadLeft(2, '0') ;
                UID1 = UID1.ToUpper();
                year = Convert.ToString(RecordData[8]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + " Tag-exist time-overflow";
            }
            else if ((fCmdRet == 0) &&(recordType == 3))
            {
                year = Convert.ToString(RecordData[0]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[1]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[2]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[3]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[4]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " Infrared-block-time-overflow";
            }
            else if ((fCmdRet == OK) && (recordType == 4))
            {
                 year = Convert.ToString(RecordData[0]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[1]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[2]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[3]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[4]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " Infrared-interference-warning";
            }
            else if ((fCmdRet == OK) &&(recordType == 8))
            {
                year = Convert.ToString(RecordData[0]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[1]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[2]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[3]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[4]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                year = Convert.ToString(RecordData[6]).PadLeft(2, '0');
                month = Convert.ToString(RecordData[7]).PadLeft(2, '0');
                Dates = Convert.ToString(RecordData[8]).PadLeft(2, '0');
                Hour = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                minutes = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                second = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "No." + Convert.ToString(RecordIndex) + " Record  " + "Set Real-time Clock  " + " Before Clock Set::  " + Time + "  " +"After Clock Set:  " + Time1;
            }
            AddCmdLog("S", "Get Record By Its Sequence Number", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void GetFirstRecordAndDel_Click(object sender, EventArgs e)
        {
            string UID, UID1, InOrOut;
            byte InFlag, MsgLength, recordType;
            byte[] Msg = new byte[16];
            string year, month, Dates, Hour, minutes, second;
            string Time, Time1;
            int EnterCount, LeaveCount, UnsureCount, CardNum;
            MsgLength = 0;
            recordType = 0;
            InOrOut = "";
            Time1 = "";
            fCmdRet = StaticClassReaderB.RetrieveEarliestRecord(ref ControllerAdr, Msg, ref MsgLength, ref recordType, ref FreeSpaceRate, PortHandle);
            if ((fCmdRet == 0) && (recordType == 0))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                UID = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID1 = UID1.ToUpper();
                InFlag = Convert.ToByte(Msg[8]);
                switch (InFlag)
                {
                    case 1:
                        InOrOut = "Forward";
                        break;
                    case 2:
                        InOrOut = "Reverse";
                        break;
                    case 3:
                        InOrOut = "Direction Uncertain";
                        break;
                    case 4:
                        InOrOut = "Infrared sensors closed";
                        break;

                }
                year = Convert.ToString(Msg[9]).PadLeft(2, '0');
                month = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[12]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[13]).PadLeft(2, '0');
                second = Convert.ToString(Msg[14]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                if ((UID == "0000000000000000") || (InFlag == 0))
                    TextBox11.Text = "First Record  " + Time + " None";
                else if (UID == "FFFFFFFFFFFFFFFF")
                    TextBox11.Text = "First Record " + Time + " " + UID1 + " " + InOrOut;
                else if (InOrOut == "Infrared sensors closed")
                    TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + "Infrared sensors closed";
                else
                    TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + InOrOut;
            }
            else if ((fCmdRet == OK) && (recordType == 1))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                EnterCount = Msg[1] << 8;
                EnterCount = EnterCount | Msg[0];

                LeaveCount = Msg[3] << 8;
                LeaveCount = LeaveCount | Msg[2];

                UnsureCount = Msg[5] << 8;
                UnsureCount = UnsureCount | Msg[4];

                CardNum = Msg[7] << 8;
                CardNum = CardNum | Msg[6];
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record   " + Time + " " + EnterCount + " Forward " + LeaveCount + " Reverse " + UnsureCount + " Direction Uncertain " + " Total Detect " + CardNum + " Tags";
            }
            else if ((fCmdRet == 0) && (recordType == 2))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                UID = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID1 = UID1.ToUpper();
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record  " + Time + " " + UID1 + " " + "  Tag-exist time-overflow";
            }
            else if ((fCmdRet == 0) && (recordType == 3))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record   " + Time + " Infrared-block-time-overflow";
            }
            else if ((fCmdRet == OK) && (recordType == 4))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record  " + Time + " Infrared-interference-warning";
            }
            else if ((fCmdRet == OK) && (recordType == 8))
            {
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                year = Convert.ToString(Msg[6]).PadLeft(2, '0');
                month = Convert.ToString(Msg[7]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[8]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[9]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[10]).PadLeft(2, '0');
                second = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Time1 = "20" + year + "-" + month + "-" + Dates + "-" + " " + Hour + ":" + minutes + ":" + second;
                TextBox11.Text = "First Record " + "Set Real-time Clock " + "Before Clock Set:  " + Time + "  " + "After Clock Set:  " + Time1;
            }
            else if(fCmdRet==5)
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
            AddCmdLog("E", "Get Earliest Record", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void SaveRecordAsTextFile_Click(object sender, EventArgs e)
        {
            int RecordCount, RecordIndex;
            byte[] FirstRecordTime=new byte[6];
            byte[] LastRecordTime = new byte[6];
            string  RecordString, Time ;
            string  RecordFile ;
            byte[] RecordData=new byte[16];
            string OutData, UID, UID1, InOrOut;
            byte InFlag, RecordLength, RecordType;
            string year, month, Dates, Hour, minutes, second ;
            int EnterCount, LeaveCount, UnsureCount, CardNum;
            string Path ;
             Btn_GetControllerInfo.Enabled = false;
            Btn_GetControllerParticInfo.Enabled = false;
            CloseIR.Enabled = false;
            OpenIR.Enabled = false;
            Btn_GetIRStatus.Enabled = false;
            SetRealy.Enabled = false;
            ClockCMD.Enabled = false;
            ClearBuffer.Enabled = false;
            GetReaderStatus.Enabled = false;
            button3.Enabled = false;
            button4.Enabled = false;
            ControllerInfo.Enabled = false;
            LEDAndBuzTest.Enabled = false;
            GetBackRecorfStatus.Enabled = false;
            SearchInRecord.Enabled = false;
            GetFirstRecord.Enabled = false;
            GetFirstRecordAndDel.Enabled = false;
            SaveRecordAsTextFile.Enabled = false;
            SaveAndDeleteAll.Enabled = false;
            Btn_DeleteAllRecord.Enabled = false;
            SetControAddr.Enabled = false;
            ControAddr.Enabled = false;
            SetMode.Enabled = false;
            GetMode.Enabled = false;
            Button1.Enabled = false;
            Button2.Enabled = false;
            Button5.Enabled = false;
            Button6.Enabled = false;
            Button7.Enabled = false;
            Button8.Enabled = false;
            IF1Start.Enabled = false;
            Button11.Enabled = false;
           // 'Button12.Enabled = false
            Button13.Enabled = false;
           // 'Button14.Enabled = false
            Button17.Enabled = false;
            Button18.Enabled = false;
            Button15.Enabled = false;
            Button16.Enabled = false;
            Button20.Enabled = false;
            Button23.Enabled = false;
            Path = DateTime.Now.Month.ToString().PadLeft(2, '0') + DateTime.Now.Day.ToString().PadLeft(2, '0') + DateTime.Now.Hour.ToString().PadLeft(2, '0') + DateTime.Now.Minute.ToString().PadLeft(2, '0');
            RecordFile = Path + ".text";
            RecordString = "1234567";
            FileStream fs = new FileStream(RecordFile, FileMode.Append);
            StreamWriter streamWriter = new StreamWriter(fs); 
            streamWriter.BaseStream.Seek(0, SeekOrigin.End);
            RecordCount = 0;
            fCmdRet = StaticClassReaderB.GetBGLogDataStatus(ref ControllerAdr,ref RecordCount, FirstRecordTime, LastRecordTime,ref FreeSpaceRate, PortHandle);
            try
            {
                if (fCmdRet == 0)
                    StatusBar1.Panels[0].Text = "Are storing, please wait...";
                for (RecordIndex = 1; RecordIndex < RecordCount; RecordIndex++)
                {
                    OutData = "";
                    RecordType = 0;
                    RecordLength = 0;
                    fCmdRet = StaticClassReaderB.RetrieveRecordByIndex(ref ControllerAdr, RecordIndex, RecordData, ref RecordLength, ref RecordType, ref FreeSpaceRate, PortHandle);
                    OutData = ByteArrayToHexString(RecordData);
                    if (OutData != "")
                    {
                        if ((fCmdRet == 0) && (RecordType == 0))
                        {
                            UID = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                            UID = UID.ToUpper();
                            UID1 = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                            UID1 = UID1.ToUpper();
                            InFlag = Convert.ToByte(RecordData[8]);
                            InOrOut = "";
                            switch (InFlag)
                            {
                                case 1:
                                    InOrOut = "Forward";
                                    break;
                                case 2:
                                    InOrOut = "Reverse";
                                    break;
                                case 3:
                                    InOrOut = "Direction Uncertain";
                                    break;
                                case 4:
                                    InOrOut = "Infrared sensors closed";
                                    break;
                            }
                            year = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                            month = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                            Dates = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                            Hour = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                            minutes = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                            second = Convert.ToString(RecordData[14]).PadLeft(2, '0');
                            Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                            if ((UID == "0000000000000000") || (InFlag == 0))
                                RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " None";
                            else if (UID == "FFFFFFFFFFFFFFFF")
                                RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + InOrOut;
                            else if (InOrOut == "Infrared sensors closed")
                                RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + "Infrared sensors closed";
                            else
                                RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + InOrOut;
                        }
                        else if ((fCmdRet == OK) && (RecordType == 1))
                        {
                            EnterCount = RecordData[1] << 8;
                            EnterCount = EnterCount | RecordData[0];

                            LeaveCount = RecordData[3] << 8;
                            LeaveCount = LeaveCount | RecordData[2];

                            UnsureCount = RecordData[5] << 8;
                            UnsureCount = UnsureCount | RecordData[4];

                            CardNum = RecordData[7] << 8;
                            CardNum = CardNum | RecordData[6];
                            year = Convert.ToString(RecordData[8]).PadLeft(2, '0');
                            month = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                            Dates = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                            Hour = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                            minutes = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                            second = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                            Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                            RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + EnterCount + " Forward " + LeaveCount + " Reverse " + UnsureCount + " Direction Uncertain " + " Total Detect " + CardNum + " Tags";
                        }
                        else if ((fCmdRet == 0) && (RecordType == 2))
                        {
                            UID = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                            UID = UID.ToUpper();
                            UID1 = Convert.ToString(RecordData[0], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[1], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[2], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[3], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[4], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[5], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[6], 16).PadLeft(2, '0') + " " + Convert.ToString(RecordData[7], 16).PadLeft(2, '0');
                            UID1 = UID1.ToUpper();
                            year = Convert.ToString(RecordData[8]).PadLeft(2, '0');
                            month = Convert.ToString(RecordData[9]).PadLeft(2, '0');
                            Dates = Convert.ToString(RecordData[10]).PadLeft(2, '0');
                            Hour = Convert.ToString(RecordData[11]).PadLeft(2, '0');
                            minutes = Convert.ToString(RecordData[12]).PadLeft(2, '0');
                            second = Convert.ToString(RecordData[13]).PadLeft(2, '0');
                            Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                            RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " " + UID1 + " " + " Tag-exist time-overflow";
                        }
                        else if ((fCmdRet == 0) && (RecordType == 3))
                        {
                            year = Convert.ToString(RecordData[0]).PadLeft(2, '0');
                            month = Convert.ToString(RecordData[1]).PadLeft(2, '0');
                            Dates = Convert.ToString(RecordData[2]).PadLeft(2, '0');
                            Hour = Convert.ToString(RecordData[3]).PadLeft(2, '0');
                            minutes = Convert.ToString(RecordData[4]).PadLeft(2, '0');
                            second = Convert.ToString(RecordData[5]).PadLeft(2, '0');
                            Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                            RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " Infrared-block-time-overflow";
                        }
                        else if ((fCmdRet == OK) && (RecordType == 4))
                        {
                            year = Convert.ToString(RecordData[0]).PadLeft(2, '0');
                            month = Convert.ToString(RecordData[1]).PadLeft(2, '0');
                            Dates = Convert.ToString(RecordData[2]).PadLeft(2, '0');
                            Hour = Convert.ToString(RecordData[3]).PadLeft(2, '0');
                            minutes = Convert.ToString(RecordData[4]).PadLeft(2, '0');
                            second = Convert.ToString(RecordData[5]).PadLeft(2, '0');
                            Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                            RecordString = "No." + Convert.ToString(RecordIndex) + " Record  " + Time + " Infrared-interference-warning";
                        }
                    }
                    streamWriter.WriteLine(RecordString);
                    streamWriter.Flush();
                }
            }
            finally
            {
                ;
            }
            streamWriter.Close();
             Btn_GetControllerInfo.Enabled = true;
             Btn_GetControllerParticInfo.Enabled  = true;
            CloseIR.Enabled = true;
            OpenIR.Enabled = true;
            Btn_GetIRStatus.Enabled = true;
            SetRealy.Enabled = true;
            ClockCMD.Enabled = true;
            ClearBuffer.Enabled = true;
            GetReaderStatus.Enabled = true;
            button3.Enabled = true;
            button4.Enabled = true;
            ControllerInfo.Enabled = true;
            LEDAndBuzTest.Enabled = true;
            GetBackRecorfStatus.Enabled = true;
            SearchInRecord.Enabled = true;
            GetFirstRecord.Enabled = true;
            GetFirstRecordAndDel.Enabled = true;
            SaveRecordAsTextFile.Enabled = true;
            SaveAndDeleteAll.Enabled = true;
            Btn_DeleteAllRecord.Enabled = true;
            SetControAddr.Enabled = true;
            ControAddr.Enabled = true;
            SetMode.Enabled = true;
            GetMode.Enabled = true;
            Button1.Enabled = true;
            Button2.Enabled = true;
            Button5.Enabled = true;
            Button6.Enabled = true;
            Button7.Enabled = true;
            Button8.Enabled = true;
            Button15.Enabled = true;
            Button16.Enabled = true;
            Button20.Enabled = true;
            Button23.Enabled = true;
            AddCmdLog("S", "Save All Background Log Data", fCmdRet);
        }

        private void SaveAndDeleteAll_Click(object sender, EventArgs e)
        {
            SaveRecordAsTextFile.Enabled = false;
            SaveRecordAsTextFile_Click(sender, e);
            SaveRecordAsTextFile.Enabled = true;
           if (MessageBox.Show(this, "Whether To Delete All Background Log Data", "Information", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;
            fCmdRet = StaticClassReaderB.DeleteAllRecord(ref ControllerAdr,ref FreeSpaceRate, PortHandle);
            TextBox11.Text = "";
            AddCmdLog("S", "Delete All Backend Log Data", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }

        private void Btn_DeleteAllRecord_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(this, "Whether To Delete All Background Log Data", "Information", MessageBoxButtons.OKCancel) == DialogResult.Cancel)
                return;          
            fCmdRet = StaticClassReaderB.DeleteAllRecord(ref ControllerAdr, ref FreeSpaceRate, PortHandle);
            TextBox11.Text = "";
            AddCmdLog("S", "Save And Delete All Backend Log Data", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }
        private void GetUIDAndMessage()
        { 
            string  UID, UID1, InOrOut ;
            byte InFlag, MsgLength, MsgType ;
            byte[] Msg=new byte[46];
            string year, month, Dates, Hour, minutes, second ;
            string Time, s ;           //ʱַ
            int EnterCount, LeaveCount, UnsureCount, CardNum,i;
            byte BuzActTime, BuzQuiteTime, BuzzerActTimes ;
            byte LEDOnTime, LEDOffTime, LEDFlickerTimes ;
            byte LEDColor ;
            IsGetting = true;  //ùʱִб־
            MsgLength = 0;
            MsgType = 0;
            InOrOut = "";
            fCmdRet = StaticClassReaderB.GetChannelMessage(ref ControllerAdr, Msg,ref MsgLength,ref MsgType,ref FreeSpaceRate, PortHandle);
             if ((fCmdRet == 0) &&(MsgType == 0))
             {
               UID = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[1], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[2], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[3], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[4], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[5], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[6], 16).PadLeft(2, '0') + " " + Convert.ToString(Msg[7], 16).PadLeft(2, '0');
                UID1 = UID1.ToUpper();
                InFlag = Convert.ToByte(Msg[8]);
                switch (InFlag & 0x0F)
                {
                    case 1:
                        InOrOut = "Forward";
                        break;
                    case 2:
                        InOrOut = "Reverse";
                        break;
                    case 3:
                        InOrOut = "Direction Uncertain";
                        break;
                    case 4:
                        InOrOut = "Infrared sensors closed";
                        break;     
           
                }
                year = Convert.ToString(Msg[9]).PadLeft(2, '0');
                month = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[12]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[13]).PadLeft(2, '0');
                second = Convert.ToString(Msg[14]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " "+ Hour + ":" + minutes + ":" +second;
                if (UID == "0000000000000000" && (LastMessage != UID))
                {
                    LastMessage = UID    ;     //洢UID,´αȽ
                    ListBox1.Items.Add(Time +"  None");
                    StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                }
                else if ( UID == "FFFFFFFFFFFFFFFF")
                {
                    ListBox1.Items.Add(Time + " " + UID1 + " " + InOrOut);
                    StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                }
                else if (InOrOut == "Infrared sensors closed" )
                {
                    ListBox1.Items.Add(Time + " " + UID1 + " Infrared sensors closed");
                    StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                }
                else if ((UID != "0000000000000000") && (UID != "FFFFFFFFFFFFFFFF") && (InOrOut != "Infrared sensors closed")) 
                {
                    ListBox1.Items.Add(Time + " " + UID1 + " " + InOrOut);
                    StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
                    BuzActTime = Convert.ToByte(ComboBox7.SelectedIndex);
                    BuzQuiteTime = Convert.ToByte(ComboBox6.SelectedIndex);
                    BuzzerActTimes =Convert.ToByte(ComboBox8.SelectedIndex);
                    LEDOnTime = Convert.ToByte(ComboBox2.SelectedIndex);
                    LEDOffTime = Convert.ToByte(ComboBox3.SelectedIndex);
                    LEDFlickerTimes = Convert.ToByte(ComboBox5.SelectedIndex);
                    LEDColor = 0 ;     //
                    fCmdRet = StaticClassReaderB.BuzzerAndLEDControl(ref ControllerAdr, BuzActTime, BuzQuiteTime, BuzzerActTimes, LEDOnTime, LEDOffTime, LEDFlickerTimes, LEDColor,ref FreeSpaceRate, PortHandle);
                    if (fCmdRet != 0)
                        return;
                }

                if (ListBox1.Items.Count > 0) 
                    ListBox1.TopIndex = ListBox1.Items.Count - 1  ; //ֱײ

             }
             else if((fCmdRet == OK) && (MsgType == 1))
             {
                EnterCount = Msg[1] << 8;
                EnterCount = EnterCount | Msg[0];

                LeaveCount = Msg[3]<< 8;
                LeaveCount = LeaveCount | Msg[2];

                UnsureCount = Msg[5] << 8;
                UnsureCount = UnsureCount | Msg[4];

                CardNum = Msg[7] << 8;
                CardNum = CardNum |Msg[6];
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox2.Items.Add(Time + " " + EnterCount + " Forward " + LeaveCount + " Reverse " + UnsureCount + " Direction Uncertain ");
                ListBox2.Items.Add("                   " + " Total Detect " + CardNum + " Tags");
                if (ListBox2.Items.Count > 0) 
                    ListBox2.TopIndex = ListBox2.Items.Count - 1  ; //ֱײ
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
             }
             else if((fCmdRet == OK) && (MsgType == 2))
             {
                UID = Convert.ToString(Msg[0],16).PadLeft(2, '0') +Convert.ToString(Msg[1],16).PadLeft(2, '0') + Convert.ToString(Msg[2],16).PadLeft(2, '0') + Convert.ToString(Msg[3],16).PadLeft(2, '0')  +Convert.ToString(Msg[4],16).PadLeft(2, '0')  + Convert.ToString(Msg[5],16).PadLeft(2, '0')  +Convert.ToString(Msg[6],16).PadLeft(2, '0')  +Convert.ToString(Msg[7],16).PadLeft(2, '0') ;
                UID = UID.ToUpper();
                UID1 = Convert.ToString(Msg[0],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[1],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[2],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[3],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[4],16).PadLeft(2, '0')  + " " + Convert.ToString(Msg[5],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[6],16).PadLeft(2, '0')  + " " +Convert.ToString(Msg[7],16).PadLeft(2, '0') ;
                UID1 = UID1.ToUpper();
                year = Convert.ToString(Msg[8]).PadLeft(2, '0');
                month = Convert.ToString(Msg[9]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[10]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[11]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[12]).PadLeft(2, '0');
                second = Convert.ToString(Msg[13]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox3.Items.Add(Time + " " + UID1 + " " + " Tag-exist time-overflow");
               
                if (ListBox3.Items.Count > 0) 
                    ListBox3.TopIndex = ListBox3.Items.Count - 1 ;//ֱײ
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
             }
             else if ((fCmdRet == OK) && (MsgType == 3))
             {
               year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox4.Items.Add(Time + " Infrared-block-time-overflow");
                if (ListBox4.Items.Count > 0)
                    ListBox4.TopIndex = ListBox4.Items.Count - 1 ;//ֱײ
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
             }
             else if ((fCmdRet == OK) && (MsgType == 4))
             {
                 year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                listBox5.Items.Add(Time + " Infrared-interference-warning");
                if (listBox5.Items.Count > 0) 
                    listBox5.TopIndex = listBox5.Items.Count - 1 ;//ֱײ
                StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
             }
        IsGetting = false;                //ִн,ִб־
        AddCmdLog("Get", "Get Command", fCmdRet);
        StatusBar1.Panels[1].Text = " ";
        if (fCmdRet == 0)
            RefreshFreeRate(FreeSpaceRate);
        }

        private void Button10_Click(object sender, EventArgs e)
        {
            IF1Start.Enabled = false;
            Button11.Enabled =true;
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
             if (IsGetting) //Ƿִ() 'C'
            return;           
            if (IsCloseApp) 
                this.Close();
            GetUIDAndMessage();
        }

        private void Button11_Click(object sender, EventArgs e)
        {
            IF1Start.Enabled = true;
            Button11.Enabled = false;
            timer1.Enabled = false;
        }

        private void Button14_Click(object sender, EventArgs e)
        {
               ListBox1.Items.Clear();
            ListBox2.Items.Clear();
            ListBox3.Items.Clear();
            ListBox4.Items.Clear();
            listBox5.Items.Clear();
            ListBox7.Items.Clear();
        }

        private void Button17_Click(object sender, EventArgs e)
        {
            Button17.Enabled = false ;
            Button18.Enabled =true;
            timer3.Enabled = true;
        }
        private void GetTheEasMessage()
        { 
            string  InOrOut ;
            byte InFlag, MsgLength, MsgType ;
            byte[] Msg=new byte[46];
            string year, month, Dates, Hour, minutes, second ;
            string Time ;         
            int EnterCount, LeaveCount, UnsureCount;
            IsGetting = true     ;     //ùʱִб־1.
            MsgLength = 0;
            MsgType = 0;
            InOrOut = "";
            fCmdRet = StaticClassReaderB.GetEASMessage(ref ControllerAdr, Msg,ref MsgLength,ref MsgType,ref FreeSpaceRate, PortHandle);
            if ((fCmdRet == 0) && (MsgType == 0))
            {
                InFlag = Convert.ToByte(Msg[0]);
                switch (InFlag)
                {
                    case 0:
                        InOrOut = "No person. No EAS";
                        break;
                    case 1:
                        InOrOut = "Forward";
                         break;
                    case 2:
                        InOrOut = "Reverse";
                         break;
                    case 3:
                        InOrOut = "Direction Uncertain";
                         break;
                    case 4:
                        InOrOut = "EAS alarming,Infrared sensors active";
                         break;
                    case 5:
                        InOrOut = "EAS alarming,Infrared sensors closed";
                         break;
                }
                 year = Convert.ToString(Msg[1]).PadLeft(2, '0');
                month = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[3]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[4]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[5]).PadLeft(2, '0');
                second = Convert.ToString(Msg[6]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                if ((InOrOut == "No person. No EAS") && (LastMessage != InOrOut))
                {
                    LastMessage = InOrOut  ;      //洢UID,´αȽ
                    ListBox8.Items.Add(Time + "   No person. No EAS");
                }
                else if(InOrOut != "No person. No EAS") 
                {
                    ListBox8.Items.Add(Time + "   " + InOrOut);
                if (ListBox8.Items.Count > 0) 
                    ListBox8.TopIndex = ListBox8.Items.Count - 1;
                }
            }
            else if ((fCmdRet == 0) &&(MsgType == 0x20))
            {
                 EnterCount = Msg[1] << 8;
                EnterCount = EnterCount | Msg[0];

                LeaveCount = Msg[3]<< 8;
                LeaveCount = LeaveCount | Msg[2];

                UnsureCount = Msg[5] << 8;
                UnsureCount = UnsureCount | Msg[4];
              
                year = Convert.ToString(Msg[6]).PadLeft(2, '0');
                month = Convert.ToString(Msg[7]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[8]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[9]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[10]).PadLeft(2, '0');
                second = Convert.ToString(Msg[11]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox9.Items.Add(Time + "   " + Convert.ToString(EnterCount) + " Forward " + Convert.ToString(LeaveCount) + " Reverse " + Convert.ToString(UnsureCount) + " Direction Uncertain");
                if (ListBox9.Items.Count > 0) 
                    ListBox9.TopIndex = ListBox9.Items.Count - 1 ;//ֱײ
            }
            else if ((fCmdRet == 0) && (MsgType == 0x21))
            {
               year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox10.Items.Add(Time + " Infrared-block-time-overflow");
                if (ListBox10.Items.Count > 0) 
                    ListBox10.TopIndex = ListBox10.Items.Count - 1; //ֱײ
            }
            else if ((fCmdRet == 0) &&(MsgType == 0x22))
            {
                year = Convert.ToString(Msg[0]).PadLeft(2, '0');
                month = Convert.ToString(Msg[1]).PadLeft(2, '0');
                Dates = Convert.ToString(Msg[2]).PadLeft(2, '0');
                Hour = Convert.ToString(Msg[3]).PadLeft(2, '0');
                minutes = Convert.ToString(Msg[4]).PadLeft(2, '0');
                second = Convert.ToString(Msg[5]).PadLeft(2, '0');
                Time = "20" + year + "-" + month + "-" + Dates + " " + Hour + ":" + minutes + ":" + second;
                ListBox11.Items.Add(Time + " Infrared-interference-warning");
                if (ListBox11.Items.Count > 0)
                    ListBox11.TopIndex = ListBox11.Items.Count - 1; //ֱײ
            }
            IsGetting = false  ;              //ִн,ִб־
            StaticClassReaderB.Acknowledge(ref ControllerAdr, PortHandle);
            AddCmdLog("Get", "Get Command", fCmdRet);
            StatusBar1.Panels[1].Text = " ";
            if (fCmdRet == 0)
                RefreshFreeRate(FreeSpaceRate);
        }
        private void timer3_Tick(object sender, EventArgs e)
        {
             if (IsGetting) //'Ƿִ() 'C'
                return;
            if (IsCloseApp)
                Close();
            GetTheEasMessage();
        }

        private void Button18_Click(object sender, EventArgs e)
        {
            Button17.Enabled = true;
            Button18.Enabled = false;
            timer3.Enabled = false;
        }

        private void Button19_Click(object sender, EventArgs e)
        {
              ListBox8.Items.Clear();
            ListBox9.Items.Clear();
            ListBox10.Items.Clear();
            ListBox11.Items.Clear();
        }

        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)
        {
             if (PortHandle != -1)
             {
                timer1.Enabled = false;
                timer3.Enabled = false;
                if (fCmdRet == 0) 
                {
                    if (fModel == 0)
                    {
                        IF1Start.Enabled = true;
                        Button11.Enabled = false;
                        Button17.Enabled = false;
                        Button18.Enabled = false;
                    }
                    if ((fModel == 1)&&((fModel & 0x02) == 0x02))
                    {
                        IF1Start.Enabled = false;
                        Button11.Enabled = false;
                        Button17.Enabled = true;
                        Button18.Enabled = false;
                    }
                }
             }
        StatusBar1.Panels[0].Text = " ";
        StatusBar1.Panels[1].Text = " ";
        }

        private void Button20_Click(object sender, EventArgs e)
        {
            byte[] SetData = new byte[45];
            SetData[0] = Convert.ToByte(ComboBox13.SelectedItem);
            SetData[1] = Convert.ToByte(ComboBox14.SelectedItem);
            SetData[2] = Convert.ToByte(ComboBox15.SelectedItem);
            SetData[3] = Convert.ToByte(ComboBox16.SelectedItem);
            SetData[4] = Convert.ToByte(ComboBox17.SelectedItem);
            SetData[5] = Convert.ToByte(ComboBox18.SelectedItem);
            SetData[6] = Convert.ToByte(ComboBox19.SelectedItem);
            SetData[7] = Convert.ToByte(ComboBox20.SelectedItem);
            SetData[8] = Convert.ToByte(ComboBox21.SelectedItem);
            SetData[9] = Convert.ToByte(ComboBox39.SelectedItem);
            SetData[10] = Convert.ToByte(ComboBox38.SelectedItem);
            SetData[11] = Convert.ToByte(ComboBox37.SelectedItem);
            SetData[12] = Convert.ToByte(ComboBox36.SelectedItem);
            SetData[13] = Convert.ToByte(ComboBox35.SelectedItem);
            SetData[14] = Convert.ToByte(ComboBox34.SelectedItem);
            SetData[15] = Convert.ToByte(ComboBox33.SelectedItem);
            SetData[16] = Convert.ToByte(ComboBox32.SelectedItem);
            SetData[17] = Convert.ToByte(ComboBox31.SelectedItem);
            SetData[18] = Convert.ToByte(ComboBox48.SelectedItem);
            SetData[19] = Convert.ToByte(ComboBox47.SelectedItem);
            SetData[20] = Convert.ToByte(ComboBox46.SelectedItem);
            SetData[21] = Convert.ToByte(ComboBox45.SelectedItem);
            SetData[22] = Convert.ToByte(ComboBox44.SelectedItem);
            SetData[23] = Convert.ToByte(ComboBox43.SelectedItem);
            SetData[24] = Convert.ToByte(ComboBox42.SelectedItem);
            SetData[25] = Convert.ToByte(ComboBox41.SelectedItem);
            SetData[26] = Convert.ToByte(ComboBox40.SelectedItem);
            SetData[27] = Convert.ToByte(ComboBox57.SelectedItem);
            SetData[28] = Convert.ToByte(ComboBox56.SelectedItem);
            SetData[29] = Convert.ToByte(ComboBox55.SelectedItem);
            SetData[30] = Convert.ToByte(ComboBox54.SelectedItem);
            SetData[31] = Convert.ToByte(ComboBox53.SelectedItem);
            SetData[32] = Convert.ToByte(ComboBox52.SelectedItem);
            SetData[33] = Convert.ToByte(ComboBox51.SelectedItem);
            SetData[34] = Convert.ToByte(ComboBox50.SelectedItem);
            SetData[35] = Convert.ToByte(ComboBox49.SelectedItem);
            SetData[36] = Convert.ToByte(ComboBox102.SelectedItem);
            SetData[37] = Convert.ToByte(ComboBox101.SelectedItem);
            SetData[38] = Convert.ToByte(ComboBox100.SelectedItem);
            SetData[39] = Convert.ToByte(ComboBox99.SelectedItem);
            SetData[40] = Convert.ToByte(ComboBox98.SelectedItem);
            SetData[41] = Convert.ToByte(ComboBox97.SelectedItem);
            SetData[42] = Convert.ToByte(ComboBox96.SelectedItem);
            SetData[43] = Convert.ToByte(ComboBox95.SelectedItem);
            SetData[44] = Convert.ToByte(ComboBox94.SelectedItem);
            fCmdRet = StaticClassReaderB.SetAlarmPattern(ref ControllerAdr, SetData,ref FreeSpaceRate, PortHandle);
            AddCmdLog("w", "Set", fCmdRet);
        }

        private void Button23_Click(object sender, EventArgs e)
        {
             byte Msg=0, Msg1=0, Msg2=0, Msg3=0, Msg4=0, Msg5 =0;
            byte[] OutData=new byte[46] ;         
            if (Set_Alarm.Checked )
            {
                if (CheckBox13.Checked )
                    Msg1 = 0x81;
                else
                if (CheckBox15.Checked)
                    Msg2 = 0x82;
                else
                    Msg2 = 0x80;
                if (CheckBox16.Checked)
                    Msg3 = 0x84;
                else
                    Msg3 =0x80;
                if (CheckBox17.Checked)
                    Msg4 = 0x88;
                else
                    Msg4 = 0x80;
                if (CheckBox22.Checked)
                    Msg5 = 0x90;
                else
                    Msg5 = 0x80;
                Msg =Convert.ToByte(Msg1 | Msg2 | Msg3 | Msg4 | Msg5);
                fCmdRet = StaticClassReaderB.SetAlarmMask(ref ControllerAdr, Msg, OutData,ref FreeSpaceRate, PortHandle);
                AddCmdLog("U", "Set", fCmdRet);
            }
            else
            {
                Msg = 0;
                fCmdRet = StaticClassReaderB.SetAlarmMask(ref ControllerAdr, Msg, OutData,ref FreeSpaceRate, PortHandle);
                if (fCmdRet == 0)
                {
                    Msg = OutData[0];
                    Msg1 = Convert.ToByte(Msg & 0x01);
                    if (Msg1 == 0x01)
                        CheckBox13.Checked = true;
                    else
                        CheckBox13.Checked = false;
                    Msg2 = Convert.ToByte(Msg & 0x02);
                    if (Msg2 == 0x02) 
                        CheckBox15.Checked = true;
                    else
                        CheckBox15.Checked = false;
                    Msg3 = Convert.ToByte(Msg & 0x04);
                    if (Msg3 == 0x04)
                        CheckBox16.Checked = true;
                    else
                        CheckBox16.Checked = false;
                    Msg4 =Convert.ToByte( Msg & 0x08);
                    if (Msg4 == 0x08)
                        CheckBox17.Checked = true;
                    else
                        CheckBox17.Checked = false;
                    Msg5 =Convert.ToByte( Msg & 0x10);
                    if (Msg5 == 0x10)
                        CheckBox22.Checked = true;
                    else
                        CheckBox22.Checked = false;
                    ComboBox13.SelectedIndex = OutData[1];
                    ComboBox14.SelectedIndex = OutData[2];
                    ComboBox15.SelectedIndex = OutData[3];
                    ComboBox16.SelectedIndex = OutData[4];
                    ComboBox17.SelectedIndex = OutData[5];
                    ComboBox18.SelectedIndex = OutData[6];
                    ComboBox19.SelectedIndex = OutData[7];
                    ComboBox20.SelectedIndex = OutData[8];
                    ComboBox21.SelectedIndex = OutData[9];
                    ComboBox39.SelectedIndex = OutData[10];
                    ComboBox38.SelectedIndex = OutData[11];
                    ComboBox37.SelectedIndex = OutData[12];
                    ComboBox36.SelectedIndex = OutData[13];
                    ComboBox35.SelectedIndex = OutData[14];
                    ComboBox34.SelectedIndex = OutData[15];
                    ComboBox33.SelectedIndex = OutData[16];
                    ComboBox32.SelectedIndex = OutData[17];
                    ComboBox31.SelectedIndex = OutData[18];
                    ComboBox48.SelectedIndex = OutData[19];
                    ComboBox47.SelectedIndex = OutData[20];
                    ComboBox46.SelectedIndex = OutData[21];
                    ComboBox45.SelectedIndex = OutData[22];
                    ComboBox44.SelectedIndex = OutData[23];
                    ComboBox43.SelectedIndex = OutData[24];
                    ComboBox42.SelectedIndex = OutData[25];
                    ComboBox41.SelectedIndex = OutData[26];
                    ComboBox40.SelectedIndex = OutData[27];
                    ComboBox57.SelectedIndex = OutData[28];
                    ComboBox56.SelectedIndex = OutData[29];
                    ComboBox55.SelectedIndex = OutData[30];
                    ComboBox54.SelectedIndex = OutData[31];
                    ComboBox53.SelectedIndex = OutData[32];
                    ComboBox52.SelectedIndex = OutData[33];
                    ComboBox51.SelectedIndex = OutData[34];
                    ComboBox50.SelectedIndex = OutData[35];
                    ComboBox49.SelectedIndex = OutData[36];
                    ComboBox102.SelectedIndex = OutData[37];
                    ComboBox101.SelectedIndex = OutData[38];
                    ComboBox100.SelectedIndex = OutData[39];
                    ComboBox99.SelectedIndex = OutData[40];
                    ComboBox98.SelectedIndex = OutData[41];
                    ComboBox97.SelectedIndex = OutData[42];
                    ComboBox96.SelectedIndex = OutData[43];
                    ComboBox95.SelectedIndex = OutData[44];
                    ComboBox94.SelectedIndex = OutData[45];
                }
                AddCmdLog("U", "Query", fCmdRet);
            }
        }

        private void Button12_Click(object sender, EventArgs e)
        {
           byte port=0;
           int cmdret = 0x30;
           for (port = 1; port <12;port++)
           {
                cmdret = StaticClassReaderB.OpenIF2(port);
                if (cmdret == 0)
                {
                    Button12.Enabled = false;
                    Button13.Enabled = true;
                    timer2.Enabled = true;
                    IF2Port = port;
                    break;
                }
           }
           RefreshComPort();
        }

        private void Button13_Click(object sender, EventArgs e)
        {
             int cmdret=0x30;
                 cmdret = StaticClassReaderB.CloseIF2(Convert.ToByte(IF2Port));
                 if (cmdret == 0)
                 {
                     Button12.Enabled = true;
                     Button13.Enabled = false;
                     timer2.Enabled = false;
                     IF2TagCount = 0;
                     IF2Port = -1;
                 }
            RefreshComPort();
        }
         private bool getCRC(byte[] s,ref byte crcL ,ref byte crcH)
        {
            int i, j ;
            int current_crc_value ;
            byte[] data=new byte[s.Length];
            current_crc_value = 0xFFFF;
            for( i = 0; i<= (s.Length - 1);i++)
            {
                data[i] = s[i];
                current_crc_value = current_crc_value ^ (data[i]);
                for (j = 0;j<8;j++)
                {
                    if ((current_crc_value & 0x01) != 0)
                        current_crc_value = (current_crc_value >> 1) ^ 0x8408;
                    else
                        current_crc_value = (current_crc_value >> 1);
                }
            }
            crcL = Convert.ToByte(current_crc_value & 0xFF);
            crcH = Convert.ToByte((current_crc_value >> 8) & 0xFF);

            return true;
        }
        private bool checkIF2DataCRC(byte[] cmd)
        {
            byte crcL=0, crcH=0;
            int i ;
            if (cmd.Length < 5)
                return false;
            byte[] data1=new byte[cmd.Length -2];
            for (i = 0; i< cmd.Length - 2;i++)
                data1[i] = cmd[i];
            if (!getCRC(data1,ref crcL,ref crcH) )
                return false;
            if (crcH != cmd[cmd.Length - 1])
                return false;
            if (crcL != cmd[cmd.Length - 2])
                return false;
            return true;
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
             byte[] Data=new byte[4095];
            byte[] OutData=new byte[20];
            int DataLength=0, i, m, n;
            string year, month, dates, hour, minutes, second ;
            string UID,  s, Time ;
            try
            {
                StaticClassReaderB.GetIF2Data(Data, ref DataLength);
                if (DataLength == 0)
                    return;
                for( m = 0; m< (DataLength / 20);m++)
                {
                    for( n = 0; n< 20;n++)
                        OutData[n] = Data[20 * m + n];
                    if (! checkIF2DataCRC(OutData))
                    {
                        ListBox7.Items.Add("CRC Check Error");
                        break;
                    }
                    s = ByteArrayToHexString(OutData);
                    s = s.Replace(" ", "");
                    UID = s.Substring(6, 16);
                    for (i = 1;i< 8;i++)
                        UID = UID.Insert(3 * i - 1, " ");
                    year = Convert.ToString(OutData[12]).PadLeft(2, '0');
                    month = Convert.ToString(OutData[13]).PadLeft(2, '0');
                    dates = Convert.ToString(OutData[14]).PadLeft(2, '0');
                    hour = Convert.ToString(OutData[15]).PadLeft(2, '0');
                    minutes = Convert.ToString(OutData[16]).PadLeft(2, '0');
                    second = Convert.ToString(OutData[17]).PadLeft(2, '0');
                    Time = "20" + year + "-" + month+ "-" + dates + " " + hour + ":" + minutes + ":" + second;
                    IF2TagCount = IF2TagCount + 1;
                    ListBox7.Items.Add(Time + " " + UID + "  " + Convert.ToString(IF2TagCount));
                }
            }
            finally
            {
                DataLength = 0;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            byte flag = 0;
            if(radioButton11.Checked)
            {
                flag = 0x81;
            }
            else
            {
                flag = 0x80;
            }
            fCmdRet = StaticClassReaderB.CommunicationsSetting(ref ControllerAdr, ref flag, ref FreeSpaceRate, PortHandle);
            AddCmdLog("U", "Set", fCmdRet);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            byte flag = 0;
            fCmdRet = StaticClassReaderB.CommunicationsSetting(ref ControllerAdr, ref flag, ref FreeSpaceRate, PortHandle);
            if (flag==0)
            {
                radioButton12.Checked=true;
            }
            else
            {
                radioButton11.Checked = true;
            }
            AddCmdLog("U", "Set", fCmdRet);
        }

        private void tabControl2_Selecting(object sender, TabControlCancelEventArgs e)
        {
            if(tabControl2.SelectedIndex==0)
            {
                OpenPort.Enabled = true;
                ClosePort.Enabled = false;
                if (PortHandle>1023)
                {
                    CloseNet_Click(sender,e);
                }
            }
            else
            {
                OpenNet.Enabled = true;
                CloseNet.Enabled = false;
                if((PortHandle>0)&&(PortHandle<256))
                {
                    ClosePort_Click(sender,e);
                }
            }
        }

        private void OpenNet_Click(object sender, EventArgs e)
        {
            int port, openresult = 0;
            byte Productcode = 0;
            byte MainVer = 0;
            byte SubVer = 0;
            int portNum = -1;
            string IPAddr;
            if (textBox8.Text == "")
                textBox8.Text = "FF";
            ControllerAdr = Convert.ToByte(textBox8.Text, 16); // $FF;
            if ((textBox9.Text == "") || (textBox13.Text == ""))
                MessageBox.Show("Config error!", "information");
            port = Convert.ToInt32(textBox9.Text);
            IPAddr = textBox13.Text;
            OpenNet.Enabled = false;
            openresult = StaticClassReaderB.OpenNetPort(port, IPAddr, ref ControllerAdr, ref PortHandle);
            if (openresult == 0)
            {
                CloseNet.Enabled = true;
                StatusBar1.Panels[2].Text = "TCPIP:" + portNum.ToString();
                EnableButton();
                if (StaticClassReaderB.GetControllerInfo(ref ControllerAdr, ref Productcode, ref MainVer, ref SubVer, ref FreeSpaceRate, PortHandle) == 0)
                {
                    TextBox1.Text = Convert.ToString(Productcode, 16).PadLeft(2, '0').ToUpper();
                    TextBox2.Text = Convert.ToString(MainVer, 16).PadLeft(2, '0') + "." + Convert.ToString(SubVer, 16).PadLeft(2, '0');
                    if (Convert.ToByte(MainVer) > 6)
                        Btn_GetControllerParticInfo.Enabled = true;
                }
                if (StaticClassReaderB.ModeSwitch(ref ControllerAdr, ref fModel, ref FreeSpaceRate, PortHandle) == 0)
                {
                    if (fModel == 0)
                        IF1Start.Enabled = true;
                    if (fModel == 1)
                        Button17.Enabled = true;

                    if ((fModel & 0x02) == 0x02)
                        Button17.Enabled = true;
                }
            }
            if ((openresult == 0x35) || (openresult == 0x30))
            {
                MessageBox.Show("TCPIP error", "Information");
                OpenNet.Enabled = true;
            }
        }

        private void CloseNet_Click(object sender, EventArgs e)
        {
            if(PortHandle>1023)
            {
                StaticClassReaderB.CloseNetPort(PortHandle);
                PortHandle = -1;
                InitiButton();
                RefreshComPort();
                CloseNet.Enabled = false;
                OpenNet.Enabled = true;
                ConnectStatus.Text = "";
                ANTStatus.Text = "";
                TextBox1.Text = "";
                TextBox2.Text = "";
                TextBox3.Text = "";
                TextBox4.Text = "";
                // TextBox5.Text = "";
                TextBox6.Text = "";
                TextBox7.Text = "";
                TextBox10.Text = "";
                TextBox11.Text = "";
                TextBox12.Text = "";
                TextBox14.Text = "";
                Text_year.Text = "";
                Text_month.Text = "";
                Text_day.Text = "";
                Text_min.Text = "";
                Text_hour.Text = "";
                Text_sec.Text = "";
                ListBox2.Items.Clear();
                ListBox3.Items.Clear();
                ListBox4.Items.Clear();
                listBox5.Items.Clear();
                ListBox7.Items.Clear();
                ListBox8.Items.Clear();
                ListBox9.Items.Clear();
                ListBox10.Items.Clear();
                ListBox11.Items.Clear();
                StatusBar1.Panels[0].Text = " ";
                StatusBar1.Panels[1].Text = " ";
            }
        }

        private void button21_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            string str = "";
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            byte[] data = new byte[1024];
            ListViewItem aListItem = new ListViewItem();
            try
            {
                Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                EndPoint ep = (EndPoint)iep;
                sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                string request = "X";//ʼҪ͵
                byte[] buffer = Encoding.ASCII.GetBytes(request);
                sock.SendTo(buffer, iep);
                for (int i = 0; i < 255; i++)
                {
                    byte[] buffer1 = new byte[1000];
                    sock.ReceiveTimeout = 10;
                    int m_count = sock.ReceiveFrom(buffer1, ref ep);
                    if (m_count > 0)
                    {
                        aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        aListItem.SubItems.Add("");
                        byte[] buffer2 = new byte[m_count];
                        Array.Copy(buffer1, buffer2, m_count);
                        string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                        if (fRecvIDPstring.Substring(0, 1) == "A")
                        {
                            int m = fRecvIDPstring.IndexOf('/');
                            Information.mac = fRecvIDPstring.Substring(1, m - 1);
                            Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                            m = fRecvIDPstring.IndexOf('*');
                            int n = fRecvIDPstring.Length - m - 8;
                            string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                            if (IDPstring != "")
                            {
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                            }
                            else
                            {
                                Information.usename = "";
                                Information.dsname = "";
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                str = "";
                            }
                            aListItem.SubItems[1].Text = Information.mac;
                            aListItem.SubItems[2].Text = Information.IP;
                            aListItem.SubItems[3].Text = str;
                        }
                    }
                }
                sock.Close();
            }
            catch (System.Exception ex)
            {
                ex.ToString();
                return;
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            Information.IP = "";
            Information.usename = "";
            Information.dsname = "";
            Information.mac = "";
            Information.portnum = "";
            Information.tup = "";
            Information.rm = "";
            Information.cm = "";
            Information.ct = "";
            Information.fc = "";
            Information.dt = "";
            Information.br = "";
            Information.pr = "";
            Information.bb = "";
            Information.rc = "";
            Information.ml = "";
            Information.md = "";
            Information.di = "";
            Information.dp = "";
            Information.gi = "";
            Information.nm = "";
            locateForm loginform = new locateForm();
            DialogResult result = loginform.ShowDialog();
            if (result == DialogResult.OK)
            {
                try
                {
                    string IPAddr = loginform.IP1 + "." + loginform.IP2 + "." + loginform.IP3 + "." + loginform.IP4;
                    listView1.Items.Clear();
                    string str = "";
                    byte[] data = new byte[1024];
                    ListViewItem aListItem = new ListViewItem();
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    // IPAddress broadcast = IPAddress.Parse(IPAddr);
                    // IPEndPoint iep = new IPEndPoint(broadcast, 65535);
                    IPEndPoint iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    for (int i = 0; i < 3; i++)
                    {
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        iep = new IPEndPoint(IPAddress.Parse(IPAddr), 65535);
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            aListItem = listView1.Items.Add((listView1.Items.Count + 1).ToString());
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            aListItem.SubItems.Add("");
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('/');
                                Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                m = fRecvIDPstring.IndexOf('*');
                                int n = fRecvIDPstring.Length - m - 8;
                                string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                if (((Information.usename == "") && (Information.dsname == "")) || (Information.dsname == "/"))
                                {
                                    str = "";
                                }
                                else
                                {
                                    str = Information.usename + '/' + Information.dsname;
                                }
                                if (IPAddr == Information.IP)
                                {
                                    aListItem.SubItems[1].Text = Information.mac;
                                    aListItem.SubItems[2].Text = Information.IP;
                                    aListItem.SubItems[3].Text = str;
                                }
                            }
                            break;
                        }

                    }
                    sock.Close();
                }
                catch (System.Exception ex)
                {
                    ex.ToString();
                }
            }
            loginform.Dispose();
        }

        private void button24_Click(object sender, EventArgs e)
        {
            int i = 0;
            string IPaddr = "";
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    IPaddr = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP

                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(IPaddr), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {

                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('/');
                                Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                Information.portnum = fRecvIDPstring.Substring(m + 1, 4);
                                m = fRecvIDPstring.IndexOf('*');
                                int n = fRecvIDPstring.Length - m - 8;
                                string IDPstring = fRecvIDPstring.Substring(m + 8, n);
                                Information.usename = IDPstring.Substring(0, IDPstring.IndexOf('/'));
                                Information.dsname = IDPstring.Substring(IDPstring.IndexOf('/') + 1, IDPstring.Length - IDPstring.IndexOf('/') - 1);
                                Information.IP = ep.ToString().Substring(0, ep.ToString().IndexOf(':'));
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "W" + Information.mac;//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "L";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GON|1";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "1")
                                {
                                    Information.usename = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDN|2";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "2")
                                {
                                    Information.dsname = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFE|3";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "3")
                                {
                                    Information.mac = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GIP|4";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "4")
                                {
                                    Information.IP = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPN|5";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "5")
                                {
                                    Information.portnum = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GTP|6";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "6")
                                {
                                    Information.tup = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRM|7";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "7")
                                {
                                    Information.rm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCM|8";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "8")
                                {
                                    Information.cm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GCT|9";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 1) == "9")
                                {
                                    Information.ct = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GFC|10";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "10")
                                {
                                    Information.fc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDT|11";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "11")
                                {
                                    Information.dt = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBR|12";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "12")
                                {
                                    Information.br = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GPR|13";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "13")
                                {
                                    Information.pr = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GBB|14";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "14")
                                {
                                    Information.bb = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GRC|15";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "15")
                                {
                                    Information.rc = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GML|16";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "16")
                                {
                                    Information.ml = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GMD|17";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "17")
                                {
                                    Information.md = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDI|18";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "18")
                                {
                                    Information.di = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GDP|19";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "19")
                                {
                                    Information.dp = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GGI|20";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "20")
                                {
                                    Information.gi = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    i = 0;
                    request = "GNM|21";//ʼҪ͵
                    buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            byte[] buffer2 = new byte[m_count];
                            Array.Copy(buffer1, buffer2, m_count);
                            string fRecvIDPstring = Encoding.ASCII.GetString(buffer2);
                            if (fRecvIDPstring.Substring(0, 1) == "A")
                            {
                                int m = fRecvIDPstring.IndexOf('|');
                                if (fRecvIDPstring.Substring(m + 1, 2) == "21")
                                {
                                    Information.nm = fRecvIDPstring.Substring(1, m - 1);
                                }
                                i = 3;
                                break;
                            }
                        }
                        i = i + 1;
                    }

                    if ((Information.nm == "") || (Information.mac == "") || (Information.IP == "") || (Information.portnum == "") ||
                        (Information.br == "") || (Information.bb == "") || (Information.dt == "") || (Information.rm == "") ||
                        (Information.tup == "") || (Information.pr == "") || (Information.fc == "") || (Information.di == "") || (Information.dp == "") || (Information.gi == ""))
                    {
                        MessageBox.Show("Please check device and PC connection status!", "Information");
                        return;
                    }
                    fSetdlg fsetdlg = new fSetdlg();
                    fsetdlg._IP(Information.IP);
                    fsetdlg._bb(Information.bb);
                    fsetdlg._br(Information.br);
                    fsetdlg._di(Information.di);
                    fsetdlg._dp(Information.dp);
                    fsetdlg._dsname(Information.dsname);
                    fsetdlg._dt(Information.dt);
                    fsetdlg._fc(Information.fc);
                    fsetdlg._gi(Information.gi);
                    fsetdlg._MAC(Information.mac);
                    fsetdlg._nm(Information.nm);
                    fsetdlg._portnum(Information.portnum);
                    fsetdlg._pr(Information.pr);
                    fsetdlg._rm(Information.rm);
                    fsetdlg._tup(Information.tup);
                    fsetdlg._usename(Information.usename);
                    DialogResult result = fsetdlg.ShowDialog();
                    if (result == DialogResult.OK)
                    {
                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|37";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(500);

                        iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                        sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);

                        request = "W" + Information.mac;//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(100);

                        request = "L";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(50);

                        request = "SON" + Information.usename + "|18";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDN" + Information.dsname + "|19";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "STP" + Information.tup + "|20";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPN" + Information.portnum + "|21";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRM" + Information.rm + "|22";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SFC" + Information.fc + "|23";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDT" + Information.dt + "|24";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBR" + Information.br + "|25";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SPR" + Information.pr + "|26";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SBB" + Information.bb + "|27";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SRC" + Information.rc + "|28";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCM" + Information.cm + "|29";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SCT" + Information.ct + "|30";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SML" + Information.ml + "|31";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SMD" + Information.md + "|32";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDI" + Information.di + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SDP" + Information.dp + "|34";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SGI" + Information.gi + "|35";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SNM" + Information.nm + "|36";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "SIP" + Information.IP + "|33";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);

                        request = "E";//ʼҪ͵
                        buffer = Encoding.ASCII.GetBytes(request);
                        sock.SendTo(buffer, iep);
                        Thread.Sleep(10);
                        listView1.Items.Clear();
                    }
                    fsetdlg.Dispose();
                    sock.Close();
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void button25_Click(object sender, EventArgs e)
        {
            string IPAddr = "";
            ChangeIPdlg changeIPdlg = new ChangeIPdlg();
            DialogResult result = changeIPdlg.ShowDialog();
            if (result == DialogResult.OK)
            {
                IPAddr = changeIPdlg.IP1 + "." + changeIPdlg.IP2 + "." + changeIPdlg.IP3 + "." + changeIPdlg.IP4;
            }
            else
            {
                return;
            }
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Information.mac = listView1.SelectedItems[0].SubItems[1].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP
                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    //   sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "X";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(10);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(200);

                    iep = new IPEndPoint(IPAddress.Broadcast, 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);
                    request = "W" + Information.mac;
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "L";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(50);

                    request = "SIP" + IPAddr + "|34";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    Thread.Sleep(100);

                    request = "E|35";
                    buffer = Encoding.ASCII.GetBytes(request);
                    sock.SendTo(buffer, iep);
                    sock.Close();
                    listView1.Items.Clear();
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }

            }
            catch (Exception ex)
            {
                ex.ToString();
            }
            changeIPdlg.Dispose();
        }

        private void button26_Click(object sender, EventArgs e)
        {
            int i = 0;
            try
            {
                if (listView1.SelectedIndices.Count > 0
                    && listView1.SelectedIndices[0] != -1)
                {
                    Information.IP = listView1.SelectedItems[0].SubItems[2].Text;
                    Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);//ʼһScoketʵϰ,UDP

                    IPEndPoint iep = new IPEndPoint(IPAddress.Parse(Information.IP), 65535);//ʼһ͹㲥ָ˿ڵ˿ʵ
                    EndPoint ep = (EndPoint)iep;
                    sock.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.Broadcast, 1);//øscoketʵķʽ
                    string request = "B";//ʼҪ͵
                    byte[] buffer = Encoding.ASCII.GetBytes(request);
                    while (i < 3)
                    {
                        sock.SendTo(buffer, iep);
                        byte[] buffer1 = new byte[1000];
                        sock.ReceiveTimeout = 10;
                        int m_count = sock.ReceiveFrom(buffer1, ref ep);
                        if (m_count > 0)
                        {
                            i = 3;
                            sock.Close();
                            break;
                        }
                        i = i + 1;
                    }
                }
                else
                {
                    MessageBox.Show("No select device!", "Information");
                }
            }
            catch (Exception ex)
            {
                ex.ToString();
            }
        }

        private void button22_Click(object sender, EventArgs e)
        {
            byte EASmode = 0;
            byte AFI = 0;
            if (textBox17.Text.Length == 0)
            {
                MessageBox.Show("Please input AFI!", "Information");
                return;
            }
            if (radioButton_EAS.Checked)
            {
                EASmode = 0;
            }
            else
            {
                EASmode = 1;
            }
            AFI = Convert.ToByte(textBox17.Text, 16);
            fCmdRet = StaticClassReaderB.SetEASWorkStyle(ref ControllerAdr, EASmode, AFI, ref FreeSpaceRate, PortHandle);
            AddCmdLog("s", "SetEASWorkStyle", fCmdRet);
        }

        private void button10_Click_1(object sender, EventArgs e)
        {
            byte EASmode = 0;
            byte AFI = 0;
            fCmdRet = StaticClassReaderB.GetEASWorkStyle(ref ControllerAdr, ref EASmode, ref AFI, ref FreeSpaceRate, PortHandle);
            if (fCmdRet == 0)
            {
                if (EASmode == 0)
                    radioButton_EAS.Checked = true;
                else
                    radioButton_AFI.Checked = true;
                textBox17.Text = Convert.ToString(AFI, 16).PadLeft(2, '0');
            }
            AddCmdLog("s", "GetEASWorkStyle", fCmdRet);
        }

        


    }
}