unit IRCON_Head;

interface

Const
    OK			              = $00;    
    StatInforBlock        = $01;
    TagOverTimeBlock      = $02;
    PassOverTimeBlock     = $03;
    InfraredAlarmBlock    = $04;    
    BackGroundDataErr	    = $05;
    ControlerInitializing = $06;
    IndexOutOfRange       = $07;
    FindConfigDataError   = $08;
    IRClosed              = $09;
    GetRecordTimeError    = $0A;
    ConstraintSetEAS      = $0B;
    SaveNewIRError        = $0C;
    OpenIRC               = $0D;
    BackRecord            = $0E;
    ErrorMessage          = $ff;
    FindingConfigData     = $0f;
    EASStatInforBlock     = $20;
    EASPassOverTimeBlock  = $21;
    EASInfraredAlarmBlock = $22;
    
    CommunicationErr = $30;
    RetCRCErr        = $31;
    RetDataErr       = $32;    //ݳ
    CommunicationBusy= $33;

    Function IRCON_GetReturnCodeDesc(retCode : Byte) : String;
Function GeteCodeDesc(retCode : string) : String;

implementation

Function GeteCodeDesc(retCode : string) : String;
begin
    result := '';
    if(retCode='C')then
    begin
       result := 'Command Error';
    end
    else if(retCode='R')then
    begin
      Result:='Device refused to do the order';
    end
    else if(retCode='D')then
    begin
      Result:='can not connect with device';
    end
    else if(retCode='F') then
    begin
      Result:='Command execution failed';
    end;
end;

Function IRCON_GetReturnCodeDesc(retCode : Byte) : String;
begin
  result := '';
  case retCode of
    OK                  : result := 'Operation Successed';
    TagOverTimeBlock    : result := 'Get Tag Timeout Message';
    PassOverTimeBlock   : result := 'Get Time Overflow Message';
    InfraredAlarmBlock  : result := 'Get Infrared Alarm Message';
    IRClosed            : result := 'Mode error';
    OpenIRC             : Result := 'Can not set stop record';
    CommunicationErr    : result := 'Communication error';
    FindConfigDataError : result := 'Invalid Command';
    IndexOutOfRange     : result := 'Search out of range';
    FindingConfigData   : result := 'Are looking for information....';
    RetCRCErr           : result := 'CRC Check error';
    GetRecordTimeError  : result := 'Can not save New mode';
    ControlerInitializing:result := 'Ongoing internal self-test....';
    RetDataErr          : result := 'Return data length error';
    BackGroundDataErr   : result := 'Record not exist or has expired';
    CommunicationBusy   : result := 'Communication Busy';
    ConstraintSetEAS    : result := 'Be forced in EAS mode';
    SaveNewIRError      : result := 'New direction Saved Failed';
    EASPassOverTimeBlock: result := 'Get EAS Time Overflow Message';
    EASInfraredAlarmBlock:result := 'Get EAS Infrared Alarm Message';
  end;
end;

end.
